!	*****************************
	subroutine biogeo(count,aa, time)
!	*****************************
!	initialize variables
!	last modified:

	use globals
	implicit none
	
	integer i,j, count, aa, time
	real*8 sol_O2, sol_CO2, sc_O2, sc_CO2, delt_bio, ro2, rno3, rso4, min
	real*8 KK1, KK2, KK3, KK4, KK5, KKca, KKara
	real*8 K1(nbox), K2(nbox), K3(nbox), K4(nbox), K5(nbox), Kspca(nbox), Kspara(nbox)
	real*8 dK1(nmax), dK2(nmax), dK3(nmax), dK4(nmax), dK5(nmax), dKspca(nmax)
	real*8 fo2(nmax), fno3(nmax), fso4(nmax), fch4(nmax)
	real*8 fix(nbox), trans(nbox), dtrans(nmax)
	real*8 r1b(nbox), r1d(nmax), r2b(nbox), r2d(nmax), r3b(nbox), r3d(nmax), r4b(nbox), r4d(nmax)
	real*8 r5b(nbox), r5d(nmax), r6b(nbox), r6d(nmax), r7b(nbox), r7d(nmax), r8b(nbox), r8d(nmax)
	real*8 r9b(nbox), r9d(nmax), r10b(nbox), r10d(nmax), r11b(nbox), r11d(nmax), r12b(nbox), r12d(nmax)
	real*8 r13b(nbox), r13d(nmax), r14b(nbox), r15b(nbox), r16b(nbox)
	real*8 co2(nbox), co3(nbox), hco3(nbox)
	real*8 dco2(nmax), dco3(nmax), dhco3(nmax)
	real*8 xi1, xi2, xi3, gamma1, gamma2, beta1, beta2
	real*8 omegaca, c_caco3(nbox), test1, test2
	real*8 ta_carb, newh, oldh, fh, pHcount
	real*8 kkkk, kkk, kk, lll
	
		delt_bio=delt/rbio

!	**************************************************************************	
!___air-sea exchange
!	**************************************************************************		
	sp(o2)%sol(cs)=sol_O2(sp(tem)%atm(cs),  sp(o2)%atm(cs))
	sp(o2)%sol(is)=sol_O2(sp(tem)%atm(is),  sp(o2)%atm(is))
	sp(o2)%sol(ps)=sol_O2(sp(tem)%atm(ps),  sp(o2)%atm(ps))
	
	sp(tc)%sol(cs)=sol_CO2(sp(tem)%atm(cs), sp(tc)%atm(cs))
	sp(tc)%sol(is)=sol_CO2(sp(tem)%atm(is), sp(tc)%atm(is))
	sp(tc)%sol(ps)=sol_CO2(sp(tem)%atm(ps), sp(tc)%atm(ps))
	
			
!	**************************************************************************
!___calculate reaction rates
!	**************************************************************************

	K1(cs)=KK1(sp(tem)%ccs, wdepth(cs))
	K2(cs)=KK2(sp(tem)%ccs, wdepth(cs))
	K3(cs)=KK3(sp(tem)%ccs, wdepth(cs))
	K4(cs)=KK4(sp(tem)%ccs, wdepth(cs))
	K5(cs)=KK5(sp(tem)%ccs, wdepth(cs))
	Kspara(cs)=KKara(sp(tem)%ccs, wdepth(cs))
	xi1          = K1(cs)*sp(h)%ccs/(sp(h)%ccs**2.0+K1(cs)*sp(h)%ccs&
				 +K1(cs)*K2(cs))
	xi2          = xi1*K2(cs)/(sp(h)%ccs)
	xi3          = 1.0-xi1-xi2
	hco3(cs) =xi1*sp(tc)%ccs
	co3(cs)  =xi2*sp(tc)%ccs
	co2(cs)  =xi3*sp(tc)%ccs
	
	K1(ps)=KK1(sp(tem)%cps, wdepth(ps))
	K2(ps)=KK2(sp(tem)%cps, wdepth(ps))
	K3(ps)=KK3(sp(tem)%cps, wdepth(ps))
	K4(ps)=KK4(sp(tem)%ccs, wdepth(cs))
	K5(ps)=KK5(sp(tem)%cps, wdepth(ps))
	xi1          = K1(ps)*sp(h)%cps/(sp(h)%cps**2.0+K1(ps)*sp(h)%cps&
				 +K1(ps)*K2(ps))
	xi2          = xi1*K2(ps)/(sp(h)%cps)
	xi3          = 1.0-xi1-xi2
	hco3(ps) =xi1*sp(tc)%cps
	co3(ps)  =xi2*sp(tc)%cps
	co2(ps)  =xi3*sp(tc)%cps

	K1(is)=KK1(sp(tem)%cis, wdepth(is))
	K2(is)=KK2(sp(tem)%cis, wdepth(is))
	K3(is)=KK3(sp(tem)%cis, wdepth(is))
	K4(is)=KK4(sp(tem)%ccs, wdepth(cs))
	K5(is)=KK5(sp(tem)%cis,wdepth(is))
	xi1          = K1(is)*sp(h)%cis/(sp(h)%cis**2.0+K1(is)*sp(h)%cis&
				 +K1(is)*K2(is))
	xi2          = xi1*K2(is)/(sp(h)%cis)
	xi3          = 1.0-xi1-xi2
	hco3(is) =xi1*sp(tc)%cis
	co3(is)  =xi2*sp(tc)%cis
	co2(is)  =xi3*sp(tc)%cis

	K1(cd)=KK1(sp(tem)%ccd, wdepth(cd))
	K2(cd)=KK2(sp(tem)%ccd, wdepth(cd))
	K3(cd)=KK3(sp(tem)%ccd, wdepth(cd))
	K4(cd)=KK4(sp(tem)%ccs, wdepth(cs))
	K5(cd)=KK5(sp(tem)%ccd,wdepth(cd))
	Kspca(cd)=KKca(sp(tem)%ccd, wdepth(cd))
	xi1          = K1(cd)*sp(h)%ccd/(sp(h)%ccd**2.0+K1(cd)*sp(h)%ccd&
				 +K1(cd)*K2(cd))
	xi2          = xi1*K2(cd)/(sp(h)%ccd)
	xi3          = 1.0-xi1-xi2
	hco3(cd) =xi1*sp(tc)%ccd
	co3(cd)  =xi2*sp(tc)%ccd
	co2(cd)  =xi3*sp(tc)%ccd

	K1(pd)=KK1(sp(tem)%cpd,wdepth(pd))
	K2(pd)=KK2(sp(tem)%cpd,wdepth(pd))
	K3(pd)=KK3(sp(tem)%cpd,wdepth(pd))
	K4(pd)=KK4(sp(tem)%ccs, wdepth(cs))
	K5(pd)=KK5(sp(tem)%cpd,wdepth(pd))
	Kspca(pd)=KKca(sp(tem)%cpd,wdepth(pd))
	xi1          = K1(pd)*sp(h)%cpd/(sp(h)%cpd**2.0+K1(pd)*sp(h)%cpd&
				 +K1(pd)*K2(pd))
	xi2          = xi1*K2(pd)/(sp(h)%cpd)
	xi3          = 1.0-xi1-xi2
	hco3(pd) =xi1*sp(tc)%cpd
	co3(pd)  =xi2*sp(tc)%cpd
	co2(pd)  =xi3*sp(tc)%cpd
	
	do i=1,nmax
		dK1(i)=KK1(sp(tem)%cid(i), delxi(i))
		dK2(i)=KK2(sp(tem)%cid(i), delxi(i))
		dK3(i)=KK3(sp(tem)%cid(i), delxi(i))
		dK4(i)=KK4(sp(tem)%ccs, delxi(i))
		dK5(i)=KK5(sp(tem)%cid(i), delxi(i))
		dKspca(i)=KKca(sp(tem)%cid(i),delxi(i))
		xi1          = dK1(i)*sp(h)%cid(i)/(sp(h)%cid(i)**2.0&
						 + dK1(i)*sp(h)%cid(i)+dK1(i)*dK2(i))
		xi2          = xi1*dK2(i)/(sp(h)%cid(i))
		xi3          = 1.0-xi1-xi2
		dhco3(i) =xi1*sp(tc)%cid(i)
		dco3(i)  =xi2*sp(tc)%cid(i)
		dco2(i)  =xi3*sp(tc)%cid(i)
	enddo
	
!___export production
!_____________________________________________________________________________
	if(((sp(nh4)%ccs+sp(no3)%ccs).gt.1.0) .AND. ((sp(nh4)%ccs+sp(no3)%ccs)/sp(po4)%ccs.gt.16.0)) then
		r1b(cs)  =mu1/D_tc*min(sp(po4)%ccs/(sp(po4)%ccs+0.5),(sp(nh4)%ccs+sp(no3)%ccs)/((sp(nh4)%ccs+sp(no3)%ccs)+1.6))
		fix(cs)=1.0
	else
		r1b(cs)=mu2/D_tc*sp(po4)%ccs/(sp(po4)%ccs+0.5)
		fix(cs)=0.0
	endif
	
	if(((sp(nh4)%cis+sp(no3)%cis).gt.1.0) .AND. ((sp(nh4)%cis+sp(no3)%cis)/sp(po4)%cis.gt.16.0)) then
		r1b(is)=mu1/D_tc*min(sp(po4)%cis/(sp(po4)%cis+0.5),(sp(nh4)%cis+sp(no3)%cis)/((sp(nh4)%cis+sp(no3)%cis)+1.6))
		fix(is)=1.0
	else
		r1b(is)=mu2/D_tc*sp(po4)%cis/(sp(po4)%cis+0.5)
		fix(is)=0.0
	endif
	
	if(((sp(nh4)%cps+sp(no3)%cps).gt.1.0) .AND. ((sp(nh4)%cps+sp(no3)%cps)/sp(po4)%cps.gt.16.0)) then
		r1b(ps)=mu1/D_tc*min(sp(po4)%cps/(sp(po4)%cps+0.5),(sp(nh4)%cps+sp(no3)%cps)/((sp(nh4)%cps+sp(no3)%cps)+1.6))
		fix(ps)=1.0
	else
		r1b(ps)=mu2/D_tc*sp(po4)%cps/(sp(po4)%cps+0.5)
		fix(ps)=0.0
	endif
	

	
!___POC remineralization
!_____________________________________________________________________________	
	r2b(cd)=sp(poc)%ccs*(1.0-(a/(a+D_co/set_poc))**nu)/(D_co)		
	r2b(pd)=sp(poc)%cps*(1.0-(a/(a+D_do/set_poc))**nu_po)/(D_do)
	r2d(1)=0.0
	do i=2, nmax
		r2d(i)=(sp(poc)%cid(i-1)-sp(poc)%cid(i))/10.0
	enddo	
	
!___nitrification
!_____________________________________________________________________________	
	r7b(cs)=knit*sp(o2)%ccs/(sp(o2)%ccs+KO2redox)*sp(nh4)%ccs
	r7b(cd)=knit*sp(o2)%ccd/(sp(o2)%ccd+KO2redox)*sp(nh4)%ccd
	r7b(ps)=knit*sp(o2)%cps/(sp(o2)%cps+KO2redox)*sp(nh4)%cps
	r7b(pd)=knit*sp(o2)%cpd/(sp(o2)%cpd+KO2redox)*sp(nh4)%cpd
	r7b(is)=knit*sp(o2)%cis/(sp(o2)%cis+KO2redox)*sp(nh4)%cis
	r7d(1)=0.0
	do i=1, nmax
		r7d(i) =knit*sp(o2)%cid(i)/(sp(o2)%cid(i)+KO2redox)*sp(nh4)%cid(i)
	enddo
	
	
!___Sulfide reoxidation
!_____________________________________________________________________________	
	r8b(cs)=ksreox*sp(o2)%ccs/(sp(o2)%ccs+KO2redox)*sp(ts)%ccs
	r8b(cd)=ksreox*sp(o2)%ccd/(sp(o2)%ccd+KO2redox)*sp(ts)%ccd
	r8b(ps)=ksreox*sp(o2)%cps/(sp(o2)%cps+KO2redox)*sp(ts)%cps
	r8b(pd)=ksreox*sp(o2)%cpd/(sp(o2)%cpd+KO2redox)*sp(ts)%cpd
	r8b(is)=ksreox*sp(o2)%cis/(sp(o2)%cis+KO2redox)*sp(ts)%cis
	do i=1, nmax
		r8d(i) =ksreox*sp(o2)%cid(i)/(sp(o2)%cid(i)+KO2redox)*sp(ts)%cid(i)
	enddo
	
!___AOM
!_____________________________________________________________________________	
	r9b(cs)=kaom*sp(so4)%ccs/(sp(so4)%ccs+KSO4redox)*sp(ch4)%ccs
	r9b(cd)=kaom*sp(so4)%ccd/(sp(so4)%ccd+KSO4redox)*sp(ch4)%ccd
	r9b(ps)=kaom*sp(so4)%cps/(sp(so4)%cps+KSO4redox)*sp(ch4)%cps
	r9b(pd)=kaom*sp(so4)%cpd/(sp(so4)%cpd+KSO4redox)*sp(ch4)%cpd
	r9b(is)=kaom*sp(so4)%cis/(sp(so4)%cis+KSO4redox)*sp(ch4)%cis
	do i=1, nmax
		r9d(i) =kaom*sp(so4)%cid(i)/(sp(so4)%cid(i)+KSO4redox)*sp(ch4)%cid(i)
	enddo
	
!___Methane reoxidation
!_____________________________________________________________________________	
	r10b(cs)=kmreox*sp(o2)%ccs/(sp(o2)%ccs+KO2redox)*sp(ch4)%ccs
	r10b(cd)=kmreox*sp(o2)%ccd/(sp(o2)%ccd+KO2redox)*sp(ch4)%ccd
	r10b(ps)=kmreox*sp(o2)%cps/(sp(o2)%cps+KO2redox)*sp(ch4)%cps
	r10b(pd)=kmreox*sp(o2)%cpd/(sp(o2)%cpd+KO2redox)*sp(ch4)%cpd
	r10b(is)=kmreox*sp(o2)%cis/(sp(o2)%cis+KO2redox)*sp(ch4)%cis
	do i=1, nmax
		r10d(i) =kmreox*sp(o2)%cid(i)/(sp(o2)%cid(i)+KO2redox)*sp(ch4)%cid(i)
	enddo
	
!___Pyrite formation
!_____________________________________________________________________________	
	r11b(cs)=kpyr*sp(ts)%ccs/(h2s_0+sp(ts)%ccs)
	r11b(cd)=kpyr*sp(ts)%ccd/(h2s_0+sp(ts)%ccd)
	r11b(ps)=kpyr*sp(ts)%cps/(h2s_0+sp(ts)%cps)
	r11b(pd)=kpyr*sp(ts)%cpd/(h2s_0+sp(ts)%cpd)
	r11b(is)=kpyr*sp(ts)%cis/(h2s_0+sp(ts)%cis)
	do i=1, nmax
		r11d(i) =kpyr*sp(ts)%cid(i)/(h2s_0+sp(ts)%cid(i))
	enddo
	
!___Carbonate diss/prec
!_____________________________________________________________________________	
!___shallow water carbonates
!_____________________________________________________________________________	
	omegaca=ca*co3(cs)/(Kspara(cs))
	if(omegaca.gt.1.0)then
		r12b(cs)=kreef*Areef/(Ac*D_tc)*(omegaca-1.0)**(1.7)
	endif
	r12b(ps)=0.0
	r12b(is)=0.0
	
	r13b(cs)=0.0
	r13b(ps)=0.0
	r13b(is)=0.0
	
	omegaca=ca*co3(cd)/Kspca(cd)
	if(omegaca.gt.1.0)then
		r12b(cd)=0.0
		r13b(cd)=0.0
	else
		r12b(cd)=0.0
		r13b(cd)=kcaco3*sp(caco3)%ccd/set_poc*(1.0-omegaca)**nca
		if(r13b(cd)*D_co.gt.rpicpoc*(r1b(ps)*D_tc))then
			r13b(cd)=rpicpoc*(r1b(cs)*D_tc)/D_co
		endif
	endif	
	
	omegaca=ca*co3(pd)/Kspca(pd)
	if(omegaca.gt.1.0)then
		r12b(pd)=0.0
		r13b(pd)=0.0
	else
		r13b(pd)=kcaco3*sp(caco3)%cpd/set_poc*(1.0-omegaca)**nca
		if(r13b(pd)*D_do.gt.rpicpoc*(r1b(ps)*D_tc))then
			r13b(pd)=rpicpoc*(r1b(ps)*D_tc)/D_do
		endif
		r12b(pd)=0.0
	endif

    omegaca=ca*dco3(1)/dKspca(1)
	if(omegaca.gt.1.0)then
			r12d(1) =0.0
			r13d(1) =0.0
		else
			r13d(1) =kcaco3*sp(caco3)%cis/set_poc*(1.0-omegaca)**nca
			r12d(1) =0.0
		endif
	do i=2, nmax
		omegaca=ca*dco3(i)/dKspca(i)
		if(omegaca.gt.1.0)then
			r12d(i) =0.0
			r13d(i) =0.0
		else
			r13d(i) =kcaco3*sp(caco3)%cid(i-1)/set_poc*(1.0-omegaca)**nca
			r12d(i) =0.0
		endif
	enddo
	
	
!___air/sea exchange
!_____________________________________________________________________________	
	sp(o2)%gex =17.4375*(sc_O2(sp(tem)%ccs)/600.0)**(-0.5)*24.0*365.0/100.0		!Wanninkhof, 1992 assuming average wind speed of 7.5 m/s
	r14b(cs)=sp(o2)%gex/D_tc*(sp(o2)%sol(cs)-sp(o2)%ccs)
	sp(o2)%gex =17.4375*(sc_O2(sp(tem)%cis)/600.0)**(-0.5)*24.0*365.0/100.0	
	r14b(is)=sp(o2)%gex/D_tc*(sp(o2)%sol(is)-sp(o2)%cis)
	sp(o2)%gex =17.4375*(sc_O2(sp(tem)%cps)/600.0)**(-0.5)*24.0*365.0/100.0
	r14b(ps)=sp(o2)%gex/D_tc*(sp(o2)%sol(ps)-sp(o2)%cps)
	
		
	
	sp(tc)%gex =17.4375*(sc_CO2(sp(tem)%ccs)/600.0)**(-0.5)*24.0*365.0/100.0	
	r15b(cs)=sp(tc)%gex/D_tc*(sp(tc)%sol(cs)-cas(sh2co3)%ccs)
	sp(tc)%gex =17.4375*(sc_CO2(sp(tem)%cis)/600.0)**(-0.5)*24.0*365.0/100.0	
	r15b(is)=sp(tc)%gex/D_tc*(sp(tc)%sol(is)-cas(sh2co3)%cis)
	sp(tc)%gex =17.4375*(sc_CO2(sp(tem)%cps)/600.0)**(-0.5)*24.0*365.0/100.0
	r15b(ps)=sp(tc)%gex/D_tc*(sp(tc)%sol(ps)-cas(sh2co3)%cps)
	
		
!************************************************************************************************************
!_____________________________________________________________________________	
!_____________________________________________________________________________		
!___calculate factors
	do i=1, nmax
		if(sp(o2)%cid(i).gt.kmo2) then
			fo2(i)=1.0
			fno3(i)=0.0
		else
			fo2(i)=sp(o2)%cid(i)/kmo2
			if (sp(no3)%cid(i).gt.kmno3) then
				fno3(i)=1.0-fo2(i)
			else
				fno3(i)=(1.0-fo2(i))*sp(no3)%cid(i)/kmno3
			endif
		endif
		if (fo2(i)+fno3(i).gt.1) then
			fso4(i)=0.0
		else if (sp(so4)%cid(i).gt.kmso4) then
			fso4(i)=(1.0-(fo2(i)+fno3(i)))
		else
			fso4(i)=(1.0-(fo2(i)+fno3(i)))*sp(so4)%cid(i)/kmso4
		endif
		fch4(i)=1.0-fo2(i)-fno3(i)-fso4(i)
		if(fch4(i).lt.0.0)then									! prevent small negative fch4 resulting from numerical errors in the range of 1E-20
			fch4(i)=0.0
		endif	
	enddo

!___calculate fraction of degradation pathways for deep boxes
!___coastal box
	ro2 =(-r10b(cd)-r8b(cd)-r7b(cd))*delt_bio
	rno3=(-r7b(cd))*delt_bio
	rso4=(-r9b(cd))*delt_bio
	
	if(r2b(cd)*delt_bio.gt.sp(o2)%ccd+ro2) then
		r3b(cd)=(sp(o2)%ccd+ro2)/delt_bio
		if((r2b(cd)-r3b(cd))*delt_bio.gt.sp(no3)%ccd+rno3) then
			r4b(cd)=(sp(no3)%ccd+rno3)/delt_bio
			if((r2b(cd)-r3b(cd)-r4b(cd))*delt_bio.gt.sp(so4)%ccd+rso4) then
				r5b(cd)=(sp(so4)%ccd+rso4)/delt_bio
				r6b(cd)=r2b(cd)-r3b(cd)-r4b(cd)-r5b(cd)
			else
				r5b(cd)=r2b(cd)-r3b(cd)-r4b(cd)
			endif
		else
			r4b(cd)=r2b(cd)-r3b(cd)
			r5b(cd)=0.0
			r6b(cd)=0.0
		endif
	
	else
		r3b(cd)=r2b(cd)
		r4b(cd)=0.0
		r5b(cd)=0.0
		r6b(cd)=0.0
	endif
!__polar box	
	ro2 =(-r10b(pd)-r8b(pd)-r7b(pd))*delt_bio
	rno3=(-r7b(pd))*delt_bio
	rso4=(-r9b(pd))*delt_bio
	
	if(r2b(pd)*delt_bio.gt.sp(o2)%cpd+ro2) then
		r3b(pd)=(sp(o2)%cpd+ro2)/delt_bio
		if((r2b(pd)-r3b(pd))*delt_bio.gt.sp(no3)%cpd+rno3) then
			r4b(pd)=(sp(no3)%cpd+rno3)/delt_bio
			if((r2b(pd)-r3b(pd)-r4b(pd))*delt_bio.gt.sp(so4)%cpd+rso4) then
				r5b(pd)=(sp(so4)%cpd+rso4)/delt_bio
				r6b(pd)=r2b(pd)-r3b(pd)-r4b(pd)-r5b(pd)
			else
				r5b(pd)=r2b(pd)-r3b(pd)-r4b(pd)
				r6b(pd)=0.0
			endif
		else
			r4b(pd)=r2b(pd)-r3b(pd)
			r5b(pd)=0.0
			r6b(pd)=0.0
		endif
	
	else
		r3b(pd)=r2b(pd)
		r4b(pd)=0.0
		r5b(pd)=0.0
		r6b(pd)=0.0
	endif
		
!************************************************************************************************************			

!	**************************************************************************
!___update concentrations
!	**************************************************************************

!___________________________________________________________________________		
!___Atmosphere
!___________________________________________________________________________																		
	mass_o2=factor_o2*38.0d21&													
			+( -r14b(cs)*D_tc*Ac -r14b(ps)*D_tc*Ap -r14b(is)*D_tc*Ai&
			-fkerw)*delt_bio	
	mass_co2=factor_co2*0.051d21&													
			+( -r15b(cs)*D_tc*Ac -r15b(ps)*D_tc*Ap -r15b(is)*D_tc*Ai&
			+fvoltc-2.0*fsilw-2.0*fbasw-fcarbw)*delt_bio	
	factor_o2 =mass_o2/38.0d21
	factor_co2=mass_co2/0.051d21
	
	fairseaco2= fairseaco2+(-r15b(cs)*D_tc*Ac -r15b(ps)*D_tc*Ap -r15b(is)*D_tc*Ai)
	fairseao2= fairseao2+(-r14b(cs)*D_tc*Ac -r14b(ps)*D_tc*Ap -r14b(is)*D_tc*Ai)
	

	!sp(o2)%atm(cs)=factor_o2*PALo2
	!sp(o2)%atm(is)=sp(o2)%atm(cs)
	!sp(o2)%atm(ps)=sp(o2)%atm(cs)
	
	!sp(tc)%atm(cs)=factor_co2*PALco2
	!sp(tc)%atm(is)=factor_co2*PALco2
	!sp(tc)%atm(ps)=factor_co2*PALco2

	
!___________________________________________________________________________
!___surface layer of the coastal ocean
!___________________________________________________________________________

	sp(tem)%ccs	=sp(tem)%ccs+sp(tem)%gex/D_tc*(sp(tem)%atm(cs)-sp(tem)%ccs)*delt_bio
	sp(poc)%ccs =r1b(cs)*D_tc
	sp(caco3)%ccs =rpicpoc*(r1b(cs)*D_tc)
	sp(o2)%ccs  =sp(o2)%ccs+  (r14b(cs)+r1b(cs)-2.0*r7b(cs)-2.0*r8b(cs)-2.0*r10b(cs))*delt_bio
	sp(nh4)%ccs =sp(nh4)%ccs+ (-r7b(cs)-fix(cs)*sp(nh4)%ccs/(sp(nh4)%ccs+5.0)*nc*r1b(cs))*delt_bio
	sp(no3)%ccs =sp(no3)%ccs+ (r7b(cs)-fix(cs)*(1.0-sp(nh4)%ccs/(sp(nh4)%ccs+5.0))*nc*r1b(cs))*delt_bio
	sp(po4)%ccs =sp(po4)%ccs+ (-pc*r1b(cs))*delt_bio+(fpw/(Ac*D_tc))*delt_bio
	sp(so4)%ccs =sp(so4)%ccs
	sp(ch4)%ccs =sp(ch4)%ccs+ (-r9b(cs)-r10b(cs))*delt_bio
	sp(ts)%ccs  =sp(ts)%ccs+ (r9b(cs)-r8b(cs)-r11b(cs))*delt_bio 
	sp(tc)%ccs  =sp(tc)%ccs+ (-r1b(cs)+r15b(cs)+r9b(cs)+r10b(cs)-rpicpoc*r1b(cs)-r12b(cs))*delt_bio&
				+1.0*((2.0*fsilw/(Ac*D_tc))*delt_bio+(2.0*fbasw/(Ac*D_tc))*delt_bio+(2.0*fcarbw/(Ac*D_tc))*delt_bio&
				+(fkerw/(Ac*D_tc))*delt_bio)
	sp(ta)%ccs  =sp(ta)%ccs+ ((1.0-sp(nh4)%ccs/(sp(nh4)%ccs+5.0))*(nc+pc)*r1b(cs)+sp(nh4)%ccs/(sp(nh4)%ccs+5.0)*(-nc+pc)*r1b(cs)&
						   -2.0*rpicpoc*r1b(cs)-2.0*r7b(cs)-2.0*r12b(cs))*delt_bio&
							+1.0*(((2.0*fsilw/(Ac*D_tc))*delt_bio+(2.0*fbasw/(Ac*D_tc))*delt_bio+(2.0*fcarbw/(Ac*D_tc))*delt_bio))				 
				
	xi1          = K1(cs)*sp(h)%ccs/(sp(h)%ccs**2.0+K1(cs)*sp(h)%ccs&
					+K1(cs)*K2(cs))
	xi2          = xi1*K2(cs)/(sp(h)%ccs)
	xi3          = 1.0-xi1-xi2
	gamma1       = K4(cs)/(K4(cs)+sp(h)%ccs)
	gamma2       = 1.0-gamma1
	beta1        = K5(cs)/(K5(cs)+sp(h)%ccs)
	beta2        = 1.0-beta1
	newh		 = sp(h)%ccs
	
	
	do
		ta_carb=sp(ta)%ccs-gamma1*sp(ts)%ccs-beta1*tb+newh-K3(cs)/newh
		newh=0.5*( (sp(tc)%ccs/ta_carb-1.0)*K1(cs) + sqrt( (1.0-sp(tc)%ccs/ta_carb)**2.0*K1(cs)**2.0 &
		-4.0*K1(cs)*K2(cs)*(1.0-2.0*sp(tc)%ccs/ta_carb) ) )
			
	
		xi1          = K1(cs)*newh/(newh**2.0+K1(cs)*newh&
						+K1(cs)*K2(cs))
		xi2          = xi1*K2(cs)/(newh)
		xi3          = 1.0-xi1-xi2
		gamma1       = K4(cs)/(K4(cs)+newh)
		gamma2       = 1.0-gamma1
		beta1        = K5(cs)/(K5(cs)+newh)
		beta2        = 1.0-beta1
		fH=sp(ta)%ccs-((xi1+2.0*xi2)*sp(tc)%ccs+gamma1*sp(ts)%ccs+beta1*tb+K3(cs)/newh-newh)
		if(abs(fH).lt.1.0d-5) exit
	enddo 
	sp(h)%ccs=newh
	cas(shco3)%ccs=xi1*sp(tc)%ccs
	cas(sco3)%ccs=xi2*sp(tc)%ccs 
	cas(sh2co3)%ccs=xi3*sp(tc)%ccs
		
!___________________________________________________________________________	
!___surface layer of the interior ocean
!___________________________________________________________________________

	sp(tem)%cis=sp(tem)%cis+sp(tem)%gex/D_tc*(sp(tem)%atm(is)-sp(tem)%cis)*delt_bio
	sp(poc)%cis   =r1b(is)*D_tc
	sp(caco3)%cis =rpicpoc*(r1b(is)*D_tc)
	sp(o2)%cis =sp(o2)%cis+ (r14b(is)+r1b(is)-2.0*r7b(is)-2.0*r8b(is)-2.0*r10b(is))*delt_bio
	sp(nh4)%cis =sp(nh4)%cis+ (-r7b(is)-fix(is)*sp(nh4)%cis/(sp(nh4)%cis+5.0)*nc*r1b(is))*delt_bio
	sp(no3)%cis =sp(no3)%cis+ (r7b(is)-fix(is)*(1.0-sp(nh4)%cis/(sp(nh4)%cis+5.0))*nc*r1b(is))*delt_bio
	sp(po4)%cis =sp(po4)%cis+ (-pc*r1b(is))*delt_bio
	sp(so4)%cis =sp(so4)%cis
	sp(ch4)%cis =sp(ch4)%cis+ (-r9b(is)-r10b(is))*delt_bio
	sp(ts)%cis  =sp(ts)%cis+ (r9b(is)-r8b(is)-r11b(is))*delt_bio 
	sp(tc)%cis  =sp(tc)%cis+ (-r1b(is)+r15b(is)+r9b(is)+r10b(is)-rpicpoc*r1b(is))*delt_bio
	sp(ta)%cis  =sp(ta)%cis+((1.0-sp(nh4)%cis/(sp(nh4)%cis+5.0))*(nc+pc)*r1b(is)+sp(nh4)%cis/(sp(nh4)%cis+5.0)*(-nc+pc)*r1b(is)&
							-2.0*rpicpoc*r1b(is)-2.0*r7b(is))*delt_bio
	
	
	xi1          = K1(is)*sp(h)%cis/(sp(h)%cis**2.0+K1(is)*sp(h)%cis&
					+K1(is)*K2(is))
	xi2          = xi1*K2(is)/(sp(h)%cis)
	xi3          = 1.0-xi1-xi2
	gamma1       = K4(is)/(K4(is)+sp(h)%cis)
	gamma2       = 1.0-gamma1
	beta1        = K5(is)/(K5(is)+sp(h)%cis)
	beta2        = 1.0-beta1
	newh		 =sp(h)%cis
	
	do
		ta_carb=sp(ta)%cis-gamma1*sp(ts)%cis-beta1*tb+newh-K3(is)/newh
		newh=0.5*( (sp(tc)%cis/ta_carb-1.0)*K1(is) + sqrt( (1.0-sp(tc)%cis/ta_carb)**2.0*K1(is)**2.0 &
		-4.0*K1(is)*K2(is)*(1.0-2.0*sp(tc)%cis/ta_carb) ) )
	
		xi1          = K1(is)*newh/(newh**2.0+K1(is)*newh&
					+K1(is)*K2(is))
		xi2          = xi1*K2(is)/(newh)
		xi3          = 1.0-xi1-xi2
		gamma1       = K4(is)/(K4(is)+newh)
		gamma2       = 1.0-gamma1
		beta1        = K5(is)/(K5(is)+newh)
		beta2        = 1.0-beta1
		fH=sp(ta)%cis-((xi1+2.0*xi2)*sp(tc)%cis+gamma1*sp(ts)%cis+beta1*tb+K3(is)/newh-newh)
		if(abs(fH).lt.1.0d-5) exit
	enddo 
	sp(h)%cis=newh
	cas(shco3)%cis=xi1*sp(tc)%cis
	cas(sco3)%cis=xi2*sp(tc)%cis 
	cas(sh2co3)%cis=xi3*sp(tc)%cis

	
!___________________________________________________________________________		
!___surface layer of the polar ocean
!___________________________________________________________________________	
	sp(tem)%cps=sp(tem)%cps+sp(tem)%gex/D_tc*(sp(tem)%atm(ps)-sp(tem)%cps)*delt_bio
	sp(poc)%cps   =r1b(ps)*D_tc
	sp(caco3)%cps =rpicpoc_po*(r1b(ps)*D_tc)
	sp(o2)%cps    =sp(o2)%cps+ (r14b(ps)+r1b(ps)-2.0*r7b(ps)-2.0*r8b(ps)-2.0*r10b(ps))*delt_bio
	sp(nh4)%cps   =sp(nh4)%cps+ (-r7b(ps)-fix(ps)*sp(nh4)%cps/(sp(nh4)%cps+5.0)*nc*r1b(ps))*delt_bio
	sp(no3)%cps   =sp(no3)%cps+ (r7b(ps)-fix(ps)*(1.0-sp(nh4)%ccs/(sp(nh4)%ccs+5.0))*nc*r1b(ps))*delt_bio
	sp(po4)%cps   =sp(po4)%cps+ (-pc*r1b(ps))*delt_bio
	sp(so4)%cps   =sp(so4)%cps
	sp(ch4)%cps   =sp(ch4)%cps+ (-r9b(ps)-r10b(ps))*delt_bio
	sp(ts)%cps    =sp(ts)%cps+ (r9b(ps)-r8b(ps)-r11b(ps))*delt_bio 
	sp(tc)%cps    =sp(tc)%cps+ (-r1b(ps)+r15b(ps)+r9b(ps)+r10b(ps)-rpicpoc*r1b(ps))*delt_bio
	sp(ta)%cps    =sp(ta)%cps + ((1.0-sp(nh4)%cps/(sp(nh4)%cps+5.0))*(nc+pc)*r1b(ps)+sp(nh4)%cps/(sp(nh4)%cps+5.0)*(-nc+pc)*r1b(ps)&
								-2.0*rpicpoc*r1b(ps)-2.0*r7b(ps))*delt_bio
	
	
	xi1          = K1(ps)*sp(h)%cps/(sp(h)%cps**2.0+K1(ps)*sp(h)%cps&
					+K1(ps)*K2(ps))
	xi2          = xi1*K2(ps)/(sp(h)%cps)
	xi3          = 1.0-xi1-xi2
	gamma1       = K4(ps)/(K4(ps)+sp(h)%cps)
	gamma2       = 1.0-gamma1
	beta1        = K5(ps)/(K5(ps)+sp(h)%cps)
	beta2        = 1.0-beta1
	newh		 = sp(h)%cps
	
	do
		ta_carb=sp(ta)%cps-gamma1*sp(ts)%cps-beta1*tb+newh-K3(ps)/newh
		newh=0.5*( (sp(tc)%cps/ta_carb-1.0)*K1(ps) + sqrt( (1.0-sp(tc)%cps/ta_carb)**2.0*K1(ps)**2.0 &
		-4.0*K1(ps)*K2(ps)*(1.0-2.0*sp(tc)%cps/ta_carb) ) )
	
		xi1          = K1(ps)*newh/(newh**2.0+K1(ps)*newh&
					+K1(ps)*K2(ps))
		xi2          = xi1*K2(ps)/(newh)
		xi3          = 1.0-xi1-xi2
		gamma1       = K4(ps)/(K4(ps)+newh)
		gamma2       = 1.0-gamma1
		beta1        = K5(ps)/(K5(ps)+newh)
		beta2        = 1.0-beta1
		fH=sp(ta)%cps-((xi1+2.0*xi2)*sp(tc)%cps+gamma1*sp(ts)%cps+beta1*tb+K3(ps)/newh-newh)
		if(abs(fH).lt.1.0d-5) exit
	enddo 
	sp(h)%cps=newh
	cas(shco3)%cps=xi1*sp(tc)%cps
	cas(sco3)%cps=xi2*sp(tc)%cps 
	cas(sh2co3)%cps=xi3*sp(tc)%cps

!___________________________________________________________________________		
!___deep layer of the polar ocean
!___________________________________________________________________________	
	sp(poc)%cpd   =sp(poc)%cps-r2b(pd)*D_do
	!sp(poc)%cpd   =sp(poc)%cps*(a/(a+D_do/set_poc))**nu_po
	sp(caco3)%cpd =sp(caco3)%cps+r12b(pd)*D_do-r13b(pd)*D_do	
	sp(o2)%cpd    =sp(o2)%cpd+ (-r3b(pd)-2.0*r7b(pd)-2.0*r8b(pd)-2.0*r10b(pd)+Fsed(o2,pd)/D_do)*delt_bio
	sp(nh4)%cpd   =sp(nh4)%cpd+ (nc*r2b(pd)-r7b(pd)+Fsed(nh4,pd)/D_do)*delt_bio
	sp(no3)%cpd   =sp(no3)%cpd+ (r7b(pd)-(4.0+3.0*nc)/5.0*r4b(pd)+Fsed(no3,pd)/D_do)*delt_bio
	sp(po4)%cpd   =sp(po4)%cpd+ (pc*r2b(pd)+Fsed(po4,pd)/D_do)*delt_bio
	sp(so4)%cpd   =sp(so4)%cpd
	sp(ch4)%cpd   =sp(ch4)%cpd+ (0.5*r6b(pd)-r9b(pd)-r10b(pd)+Fsed(ch4,pd)/D_do)*delt_bio
	sp(ts)%cpd    =sp(ts)%cpd+  (0.5*r5b(pd)+r9b(pd)-r8b(pd)-r11b(pd)+Fsed(ts,pd)/D_do)*delt_bio 
	sp(tc)%cpd    =sp(tc)%cpd+  (r2b(pd)-0.5*r6b(pd)+r13b(pd)+r9b(pd)+r10b(pd)+Fsed(tc,pd)/D_do)*delt_bio
	sp(ta)%cpd    =sp(ta)%cpd+ ((nc-2.0*pc)*r3b(pd)+(4.0+3.0*nc-10.0*pc)/5.0*r4b(pd)+(1.0+nc-2.0*pc)*r5b(pd)&
								+(nc-2.0*pc)*r6b(pd)-2.0*r8b(pd)+2.0*r9b(pd)+2.0*r13b(pd)-2.0*r7b(pd)+Fsed(ta,pd)/D_do)*delt_bio


	xi1          = K1(pd)*sp(h)%cpd/(sp(h)%cpd**2.0+K1(pd)*sp(h)%cpd&
					+K1(pd)*K2(pd))
	xi2          = xi1*K2(pd)/(sp(h)%cpd)
	xi3          = 1.0-xi1-xi2
	gamma1       = K4(pd)/(K4(pd)+sp(h)%cpd)
	gamma2       = 1.0-gamma1
	beta1        = K5(pd)/(K5(pd)+sp(h)%cpd)
	beta2        = 1.0-beta1
	newh		 = sp(h)%cpd
	
	do
		ta_carb=sp(ta)%cpd-gamma1*sp(ts)%cpd-beta1*tb+newh-K3(pd)/newh
		newh=0.5*( (sp(tc)%cpd/ta_carb-1.0)*K1(pd) + sqrt( (1.0-sp(tc)%cpd/ta_carb)**2.0*K1(pd)**2.0 &
		-4.0*K1(pd)*K2(pd)*(1.0-2.0*sp(tc)%cpd/ta_carb) ) )
	
		xi1          = K1(pd)*newh/(newh**2.0+K1(pd)*newh&
					+K1(pd)*K2(pd))
		xi2          = xi1*K2(pd)/(newh)
		xi3          = 1.0-xi1-xi2
		gamma1       = K4(pd)/(K4(pd)+newh)
		gamma2       = 1.0-gamma1
		beta1        = K5(pd)/(K5(pd)+newh)
		beta2        = 1.0-beta1
		fH=sp(ta)%cpd-((xi1+2.0*xi2)*sp(tc)%cpd+gamma1*sp(ts)%cpd+beta1*tb&
			+K3(pd)/newh-newh)
		if(abs(fH).lt.1.0d-5) exit
	enddo
	pHcount=0.0
	cas(shco3)%cpd=xi1*sp(tc)%cpd
	cas(sco3)%cpd=xi2*sp(tc)%cpd 
	cas(sh2co3)%cpd=xi3*sp(tc)%cpd 
	
!___________________________________________________________________________		
!___deep layer of the coastal ocean
!___________________________________________________________________________
	sp(poc)%ccd		=sp(poc)%ccs-r2b(cd)*D_co
	!sp(poc)%ccd   =sp(poc)%ccs*(a/(a+D_co/set_poc))**nu
	sp(caco3)%ccd =sp(caco3)%ccs+r12b(cd)*(D_co-D_tc)-r13b(cd)*(D_co-D_tc)	
	sp(o2)%ccd	=sp(o2)%ccd+  (-r3b(cd)-2.0*r7b(cd)-2.0*r8b(cd)-2.0*r10b(cd)+Fsed(o2,cd)/D_co)*delt_bio
	sp(nh4)%ccd =sp(nh4)%ccd+ (nc*r2b(cd)-r7b(cd)+Fsed(nh4,cd)/D_co)*delt_bio
	sp(no3)%ccd =sp(no3)%ccd+ (r7b(cd)-(4.0+3.0*nc)/5.0*r4b(cd)+Fsed(no3,cd)/D_co)*delt_bio
	sp(po4)%ccd =sp(po4)%ccd+ (pc*r2b(cd)+Fsed(po4,cd)/D_co)*delt_bio	
	sp(so4)%ccd =sp(so4)%ccd
	sp(ch4)%ccd =sp(ch4)%ccd+   (0.5*r6b(cd)-r9b(cd)-r10b(cd)+Fsed(ch4,cd)/D_co)*delt_bio
	sp(ts)%ccd    =sp(ts)%ccd+  (0.5*r5b(cd)+r9b(cd)-r8b(cd)-r11b(cd)+Fsed(ts,cd)/D_co)*delt_bio 
	sp(tc)%ccd    =sp(tc)%ccd+  (r2b(cd)-0.5*r6b(cd)+r13b(cd)+r9b(cd)+r10b(cd)+Fsed(tc,cd)/D_co)*delt_bio
	sp(ta)%ccd    =sp(ta)%ccd+ ((nc-2.0*pc)*r3b(cd)+(4.0+3.0*nc-10.0*pc)/5.0*r4b(cd)+(1.0+nc-2.0*pc)*r5b(cd)&
								+(nc-2.0*pc)*r6b(cd)-2.0*r8b(cd)+2.0*r9b(cd)+2.0*r13b(cd)-2.0*r7b(cd)+Fsed(ta,cd)/D_co)*delt_bio
	
								
	xi1          = K1(cd)*sp(h)%ccd/(sp(h)%ccd**2.0+K1(cd)*sp(h)%ccd&
					+K1(cd)*K2(cd))
	xi2          = xi1*K2(cd)/(sp(h)%ccd)
	xi3          = 1.0-xi1-xi2
	gamma1       = K4(cd)/(K4(cd)+sp(h)%ccd)
	gamma2       = 1.0-gamma1
	beta1        = K5(cd)/(K5(cd)+sp(h)%ccd)
	beta2        = 1.0-beta1
	newh		 = sp(h)%ccd
	do
		ta_carb=sp(ta)%ccd-gamma1*sp(ts)%ccd-beta1*tb+newh-K3(cd)/newh
		newh=0.5*( (sp(tc)%ccd/ta_carb-1.0)*K1(cd) + sqrt( (1.0-sp(tc)%ccd/ta_carb)**2.0*K1(cd)**2.0 &
		-4.0*K1(cd)*K2(cd)*(1.0-2.0*sp(tc)%ccd/ta_carb) ) )
	
		xi1          = K1(cd)*newh/(newh**2.0+K1(cd)*newh&
					+K1(cd)*K2(cd))
		xi2          = xi1*K2(cd)/(newh)
		xi3          = 1.0-xi1-xi2
		gamma1       = K4(cd)/(K4(cd)+newh)
		gamma2       = 1.0-gamma1
		beta1        = K5(cd)/(K5(cd)+newh)
		beta2        = 1.0-beta1
		fH=sp(ta)%ccd-((xi1+2.0*xi2)*sp(tc)%ccd+gamma1*sp(ts)%ccd+beta1*tb&
			+K3(cd)/newh-newh)
		if(abs(fH).lt.1.0d-5) exit
	enddo
	sp(h)%ccd=newh
	cas(shco3)%ccd=xi1*sp(tc)%ccd
	cas(sco3)%ccd=xi2*sp(tc)%ccd 
	cas(sh2co3)%ccd=xi3*sp(tc)%ccd 

!___________________________________________________________________________		
!___deep interior ocean
!___________________________________________________________________________

	sp(poc)%cid(1)  =sp(poc)%cis
	sp(caco3)%cid(1)=sp(caco3)%cis
	sp(h)%cid(1) =sp(h)%cid(2)
	do i=1,nmax
			sp(poc)%cid(i)   =sp(poc)%cis*(a/(a+(i-1)*10.0/set_poc))**nu
			sp(caco3)%cid(i) =sp(caco3)%cid(i-1)+r12d(i)*dxa(1)-r13d(i)*dxa(1)
			sp(so4)%cid(i) =sp(so4)%cid(i)
			if (i.eq.nmax-1)then
				sp(o2)%cid(i)  =sp(o2)%cid(i)+ (-fo2(i)*r2d(i)-2.0*r7d(i)-2.0*r8d(i)-2.0*r10d(i)+Fsed(o2,id)/dxa(nmax))*delt_bio
				sp(nh4)%cid(i) =sp(nh4)%cid(i)+ (nc*r2d(i)-r7d(i)+Fsed(nh4,id)/dxa(nmax))*delt_bio
				sp(no3)%cid(i) =sp(no3)%cid(i)+ (r7d(i)-(4.0+3.0*nc)/5.0*fno3(i)*r2d(i)+Fsed(no3,id)/dxa(nmax))*delt_bio
				sp(po4)%cid(i) =sp(po4)%cid(i)+ (pc*r2d(i)+Fsed(po4,id)/dxa(nmax))*delt_bio
				sp(ch4)%cid(i) =sp(ch4)%cid(i)+ (0.5*fch4(i)*r2d(i)-r9d(i)-r10d(i)+fmorch4/(Ai*dxa(nmax))+Fsed(ch4,id)/dxa(nmax))*delt_bio
				sp(ts)%cid(i)  =sp(ts)%cid(i)+  (0.5*fch4(i)*r2d(i)+r9d(i)-r8d(i)-r11d(i)+fmorh2s/(Ai*dxa(nmax))+Fsed(ts,id)/dxa(nmax))*delt_bio 
				sp(tc)%cid(i)  =sp(tc)%cid(i)+  (r2d(i)-0.5*fch4(i)*r2d(i)+r13d(i)+r9d(i)+r10d(i)+fmortc/(Ai*dxa(nmax))&
											 +  Fsed(tc,id)/dxa(nmax))*delt_bio
				sp(ta)%cid(i)  =sp(ta)%cid(i)+ ((nc-2.0*pc)*fo2(i)*r2d(i)+(4.0+3.0*nc-10.0*pc)/5.0*fno3(i)*r2d(i)&
											+(1.0+nc-2.0*pc)*fso4(i)*r2d(i)+(nc-2.0*pc)*fch4(i)*r2d(i)&
											-2.0*r8d(i)+2.0*r9d(i)+2.0*r13d(i)-2.0*r7d(i)+fmorta/(Ai*dxa(nmax))&
											+Fsed(ta,id)/dxa(nmax))*delt_bio
			else
				sp(o2)%cid(i)  =sp(o2)%cid(i)+ (-fo2(i)*r2d(i)-2.0*r7d(i)-2.0*r8d(i)-2.0*r10d(i))*delt_bio
				sp(nh4)%cid(i) =sp(nh4)%cid(i)+ (nc*r2d(i)-r7d(i))*delt_bio
				sp(no3)%cid(i) =sp(no3)%cid(i)+ (r7d(i)-(4.0+3.0*nc)/5.0*fno3(i)*r2d(i))*delt_bio
				sp(po4)%cid(i) =sp(po4)%cid(i)+ (pc*r2d(i))*delt_bio
				sp(ch4)%cid(i) =sp(ch4)%cid(i)+ (0.5*fch4(i)*r2d(i)-r9d(i)-r10d(i))*delt_bio
				sp(ts)%cid(i)  =sp(ts)%cid(i)+  (0.5*fso4(i)*r2d(i)+r9d(i)-r8d(i)-r11d(i))*delt_bio 
				sp(tc)%cid(i)  =sp(tc)%cid(i)+  (r2d(i)-0.5*fch4(i)*r2d(i)+r13d(i)+r9d(i)+r10d(i))*delt_bio
				sp(ta)%cid(i)  =sp(ta)%cid(i)+ ((nc-2.0*pc)*fo2(i)*r2d(i)+(4.0+3.0*nc-10.0*pc)/5.0*fno3(i)*r2d(i)&
											+(1.0+nc-2.0*pc)*fso4(i)*r2d(i)+(nc-2.0*pc)*fch4(i)*r2d(i)&
											-2.0*r8d(i)+2.0*r9d(i)+2.0*r13d(i)-2.0*r7d(i))*delt_bio
			endif									
			xi1          = dK1(i)*sp(h)%cid(i)/(sp(h)%cid(i)**2.0+dK1(i)*sp(h)%cid(i)&
							+dK1(i)*dK2(i))
			xi2          = xi1*dK2(i)/(sp(h)%cid(i))
			xi3          = 1.0-xi1-xi2
			gamma1       = dK4(i)/(dK4(i)+sp(h)%cid(i))
			gamma2       = 1.0-gamma1
			beta1        = dK5(i)/(dK5(i)+sp(h)%cid(i))
			beta2        = 1.0-beta1
			newh		 = sp(h)%cid(i)
			do
				ta_carb=sp(ta)%cid(i)-gamma1*sp(ts)%cid(i)-beta1*tb+newh-dK3(i)/newh
				newh=0.5*( (sp(tc)%cid(i)/ta_carb-1.0)*dK1(i) + sqrt( (1.0-sp(tc)%cid(i)/ta_carb)**2.0*dK1(i)**2.0 &
				-4.0*dK1(i)*dK2(i)*(1.0-2.0*sp(tc)%cid(i)/ta_carb) ) )
	
				xi1          = dK1(i)*newh/(newh**2.0+dK1(i)*newh&
							 +dK1(i)*dK2(i))
				xi2          = xi1*dK2(i)/(newh)
				xi3          = 1.0-xi1-xi2
				gamma1       = dK4(i)/(dK4(i)+newh)
				gamma2       = 1.0-gamma1
				beta1        = dK5(i)/(dK5(i)+newh)
				beta2        = 1.0-beta1
				fH=sp(ta)%cid(i)-((xi1+2.0*xi2)*sp(tc)%cid(i)+gamma1*sp(ts)%cid(i)+beta1*tb&
				+dK3(i)/newh-newh)
				if(abs(fH).lt.1.0d-5) exit
			enddo
	sp(h)%cid(i)=newh

	xi1          = dK1(i)*newh/(newh**2.0+dK1(i)*newh&
							 +dK1(i)*dK2(i))
	xi2          = xi1*dK2(i)/(newh)
	xi3          = 1.0-xi1-xi2
	cas(shco3)%cid(i)=xi1*sp(tc)%cid(i)
	cas(sco3)%cid(i)=xi2*sp(tc)%cid(i) 
	cas(sh2co3)%cid(i)=xi3*sp(tc)%cid(i)
	enddo


!___Write files	
!________________________________________________________
	if((count.eq.tsave).AND.(aa.eq.rbio)) then
	do i=1,nmax		
			write(2011,*) (r2d(i))
			write(2012,*) (fo2(i)*r2d(i))
			write(2013,*) (fno3(i)*r2d(i))
			write(2014,*) (fso4(i)*r2d(i))
			write(2015,*) (fch4(i)*r2d(i))
			write(2016,*) (r7d(i))
			write(2017,*) (r8d(i))
			write(2018,*) (r9d(i))
			write(2019,*) (r10d(i))
			write(2020,*) (r11d(i))
			write(2021,*) (r12d(i))
			write(2022,*) (r13d(i))
			!write(2023,*) (r15d(i))
			write(2025,*) (dKspca(i))

	enddo
			write(2210,'(F10.4, F10.4, F10.4, F10.4, F10.4)') r1b(cs), 0.0, r1b(cs), r1b(ps), 0.0
			write(2212,'(F10.4, F10.4, F10.4, F10.4, F10.4)') 0.0, r3b(cd), 0.0, 0.0, r3b(pd)
			write(2211,'(F10.4, F10.4, F10.4, F10.4, F10.4)') 0.0, r2b(cd), 0.0, 0.0, r2b(pd)
			write(2213,'(F10.4, F10.4, F10.4, F10.4, F10.4)') 0.0, r4b(cd), 0.0, 0.0, r4b(pd)
			write(2214,'(F10.4, F10.4, F10.4, F10.4, F10.4)') 0.0, r5b(cd), 0.0, 0.0, r5b(pd)
			write(2215,'(F10.4, F10.4, F10.4, F10.4, F10.4)') r6b(cs), r6b(cd), r6b(is), r6b(ps), r6b(pd)
			write(2216,'(F10.4, F10.4, F10.4, F10.4, F10.4)') r7b(cs), r7b(cd), r7b(is), r7b(ps), r7b(pd)
			write(2217,'(F10.4, F10.4, F10.4, F10.4, F10.4)') r14b(cs), r14b(cd), r14b(is), r14b(ps), r14b(pd)
			write(2218,'(F10.4, F10.4, F10.4, F10.4, F10.4)') r9b(cs), r9b(cd), r9b(is), r9b(ps), r9b(pd)
			write(2219,'(F10.4, F10.4, F10.4, F10.4, F10.4)') r10b(cs), r10b(cd), r10b(is), r10b(ps), r10b(pd)
			write(2220,'(F10.4, F10.4, F10.4, F10.4, F10.4)') r11b(cs), r11b(cd), r11b(is), r11b(ps), r11b(pd)
			write(2221,'(F10.4, F10.4, F10.4, F10.4, F10.4)') r12b(cs), r12b(cd), r12b(is), r12b(ps), r12b(pd)
			write(2222,'(F10.4, F10.4, F10.4, F10.4, F10.4)') r13b(cs), r13b(cd), r13b(is), r13b(ps), r13b(pd)
		    write(2223,'(F10.4, F10.4, F10.4, F10.4, F10.4)') r15b(cs), r15b(cd), r15b(is), r15b(ps), r15b(pd)
			write(2225,'(F10.4, F10.4, F10.4, F10.4, F10.4)') Kspara(cs), Kspca(cd), 0.0, 0.0, Kspca(pd)
	endif		

return 
end