!	*****************************
	subroutine diag(count,time, aaa, box)
!	*****************************
!   calculate dC/dt|reaction
!	last modified:

	use globals
    implicit none
	
	integer i,j, box, time, g, aaa, count
	real*8 co(nmax,spmax),dcodt(nmax,spmax)
	real*8 fo2(nmax), fno3(nmax), fso4(nmax), fch4(nmax)
	real*8 rate1(nmax), rate2(nmax), rate3(nmax), rate4(nmax), rate5(nmax), rate6(nmax), rate7(nmax)
	real*8 rate11(nmax), rate12(nmax), rate13(nmax), rate14(nmax)
	real*8 rate8(nmax)
	real*8 diff(nsed, spmax), K1, K2, K3, K4, K5, Kspca
	real*8 KK1, KK2, KK3, KK4, KK5, KKca
	real*8 xi1, xi2, xi3, gamma1, gamma2, beta1, beta2
	real*8 ta_carb, newh, oldh, fh
	real*8 delt_sed, vx, wd, aa, delt_min, tsed, temsed, omegaca, pHcount, erfcc
	real*8 co3(nmax), h2co3(nmax), hco3(nmax) 
	
	delt_sed=delt/rsed	!set max time step for sediment model
	tsed=time
	delt_min=delt_sed	!set adapting time step to max value

	select case (box)
	case (2)
	do j=1,spmax
		do i=1,nsed
			co(i,j)=sp(j)%csed_cd(i)
			diff(i,j)=sp(j)%diff(i)+Db(box)/2.0*erfcc((delxi_sed(i)*100.0-10.0)/4.0)
		enddo
	enddo
	vx=omega(cd)
	wd=D_co
	nu_sed=0.3
	aa=10
	temsed=sp(tem)%ccd
	co(1,h)=sp(j)%ccd
	case (4)
	do j=1,spmax
		do i=1,nsed
			co(i,j)=sp(j)%csed_id(i)
			diff(i,j)=sp(j)%diff(i)+Db(box)/2.0*erfcc((delxi_sed(i)*100.0-10.0)/4.0)
		enddo
	enddo
	vx=omega(id)
	wd=D_do
	nu_sed=0.2
	aa=100
	temsed=sp(tem)%cid(nmax)
	co(1,h)=sp(j)%cid(i)
	case (6)
	do j=1,spmax
		do i=1,nsed
			co(i,j)=sp(j)%csed_pd(i)
			diff(i,j)=sp(j)%diff(i)+Db(box)/2.0*erfcc((delxi_sed(i)*100.0-10.0)/4.0)
		enddo
	enddo
	vx=omega(pd)
	wd=D_do
	nu_sed=0.2
	aa=100
	temsed=sp(tem)%cpd
	co(1,h)=sp(j)%cpd
	end select

	K1=KK1(temsed, wd)
	K2=KK2(temsed, wd)
	K3=KK3(temsed, wd)
	K4=KK4(temsed, wd)
	K5=KK5(temsed, wd)
	Kspca=KKca(temsed, wd)

!___get concentration array; set box-specific properties
do while(tsed.lt.time+delt_sed)	
	delt_min=delt_sed	!set adapting time step to max value	
	
!___calculate rates
	do i=1,nsed
		if (delxi_sed(i).lt.0.1)then
			rate1(i)=nu_sed/(aa+0.05/vx)*co(i,poc)
		else
			rate1(i)=nu_sed/(aa+(0.05+delxi_sed(i)-0.1)/vx)*co(i,poc)
		endif
		rate2(i)=knit_sed*co(i,nh4)*co(i,o2)/(co(i,o2)+1.0)
		rate3(i)=kaom_sed*co(i,so4)/(co(i,so4)+KSO4redox)*co(i,ch4)
		rate4(i)=kmreox_sed*co(i,o2)/(co(i,o2)+KO2redox)*co(i,ch4)
		rate5(i)=ksreox_sed*co(i,o2)/(co(i,o2)+KO2redox)*co(i,ts)
		if(co(i,po4).gt.po4_eq)then
			rate6(i)=kapa*(co(i,po4)-po4_eq)**1.0
		else
			rate6(i)=0.0
		endif
		if(co(i,no3).gt.0.0) then
			rate7(i)=kpyr*co(i,ts)/(h2s_0+co(i,ts))
		else
			rate7(i)=0.0
		endif
		
		co3(i)=(K1*co(i,h)/(co(i,h)**2.0+K1*co(i,h)&
			+K1*K2))*K2/(co(i,h))*co(i,tc)
		omegaca=(ca*co3(i))/Kspca
		if(omegaca.gt.1.0)then
			rate8(i)=0.0
		else
			rate8(i)=0.01*co(i,caco3)*(1.0-omegaca)**nca
		endif	


		if(co(i,o2).gt.kmo2_sed) then
			fo2(i)=1.0
		else if(co(i,o2).lt.0.01) then
			fo2(i)=0.0
		else
			fo2(i)=co(i,o2)/kmo2_sed
		endif
		if (co(i,o2).gt.kmo2_sed) then
			fno3(i)=0.0
		else if (co(i,no3).gt.kmno3_sed) then
			fno3(i)=1.0-fo2(i)
		else if (co(i,no3).lt.0.01) then
			fno3(i)=0.0
		else
			fno3(i)=(1.0-fo2(i))*co(i,no3)/kmno3_sed
		endif
		if (fo2(i)+fno3(i).gt.1) then
			fso4(i)=0.0
		else if (co(i, so4).gt.kmso4_sed) then
			fso4(i)=(1.0-(fo2(i)+fno3(i)))
		else
			fso4(i)=(1.0-(fo2(i)+fno3(i)))*co(i,so4)/kmso4_sed
		endif
		fch4(i)=1.0-fo2(i)-fno3(i)-fso4(i)
		if(fch4(i).lt.0.0)then									! prevent small negative fch4 resulting from numerical errors in the range of 1E-20
			fch4(i)=0.0
		endif	
		rate11(i)=rate1(i)*fo2(i)
		rate12(i)=rate1(i)*fno3(i)
		rate13(i)=rate1(i)*fso4(i)
		rate14(i)=rate1(i)*fch4(i)
		
!___calculate dc/ct|reaction
		dcodt(i,poc)  =-rate1(i)
		dcodt(i,caco3)=-rate8(i)
		dcodt(i,2)    =0.0
		dcodt(i,o2)   =-sd(i)*fo2(i)*rate1(i)-2.0*rate2(i)-2.0*rate5(i)-2.0*rate4(i)	  
		dcodt(i,no3)  =-(4.0+3.0*nc_sed)/5.0*sd(i)*fno3(i)*rate1(i)+rate2(i)
		dcodt(i,so4)  =-0.5*sd(i)*fso4(i)*rate1(i)+rate5(i)-rate3(i)	
		dcodt(i,ch4)  =0.5*sd(i)*fch4(i)*rate1(i)-rate3(i)-rate4(i)
		dcodt(i,nh4)  =1.0/(1.0+adnh4)*sd(i)*nc_sed*(1.0-fno3(i))*rate1(i)-rate2(i)
		if(co(i,no3).gt.0.0) then
			dcodt(i,po4)  =1.0/(1.0+adpo4_ox)*(sd(i)*pc_sed*rate1(i)-rate6(i))
			diff(i,po4)   =1.0/(1.0+adpo4_ox)*diff(i,po4)
		else
			dcodt(i,po4)  =1.0/(1.0+adpo4_anox)*(sd(i)*pc_sed*rate1(i)-rate6(i))
			diff(i,po4)   =1.0/(1.0+adpo4_anox)*diff(i,po4)
		endif
		dcodt(i,ts)  =0.5*sd(i)*fso4(i)*rate1(i)-rate5(i)+rate3(i)-rate7(i)
		dcodt(i,tc)  =sd(i)*rate1(i)-0.5*sd(i)*fch4(i)*rate1(i)+rate3(i)+rate4(i)+sd(i)*rate8(i)
		dcodt(i,ta)  =sd(i)*((nc_sed-2.0*pc_sed)*fo2(i)+(4.0+3.0*nc-10.0*pc)/5.0*fno3(i)+(1.0+nc_sed-2.0*pc_sed)*fso4(i)&
					+(nc_sed-2.0*pc_sed)*fch4(i))*rate1(i)-2.0*sd(i)*rate5(i)-2.0*rate2(i)-2.0*rate3(i)+2.0*rate8(i)

!___calculate adapting time step
		do j=1,spmax
			if((dcodt(i,j).lt.0.0) .AND. (co(i,j)/-dcodt(i,j).lt.delt_min))then
				delt_min=0.9*co(i,j)/-dcodt(i,j)
				!write(6,*)box, j, delt_min, co(i,j)
			endif
		enddo
	enddo
	
	if(tsed+delt_min.gt.time+delt_sed)then
		delt_min=time+delt_sed-tsed				! make sure that t+dt is reached
	endif
	
			
!___update concentration array, calculate diffusive flux
!write(6,*) box, 'start PH loop'	
	do i=2,nsed
			do j=1,spmax
				co(i,j)=co(i,j)+delt_min*dcodt(i,j)
			enddo
			xi1          = K1*co(i,h)/(co(i,h)**2.0+K1*co(i,h)&
							+K1*K2)
			xi2          = xi1*K2/(co(i,h))
			xi3          = 1.0-xi1-xi2
			gamma1       = K4/(K4+co(i,h))
			gamma2       = 1.0-gamma1
			beta1        = K5/(K5+co(i,h))
			beta2        = 1.0-beta1
			newh		 = co(i,h)
			do
				pHcount=pHcount+1
				ta_carb=co(i,ta)-gamma1*co(i,ts)-beta1*tb+newh-K3/newh
				newh=0.5*( (co(i,tc)/ta_carb-1.0)*K1 + sqrt( (1.0-co(i,tc)/ta_carb)**2.0*K1**2.0 &
				-4.0*K1*K2*(1.0-2.0*co(i,tc)/ta_carb) ) )
	
				xi1          = K1*newh/(newh**2.0+K1*newh&
								+K1*K2)
				xi2          = xi1*K2/(newh)
				xi3          = 1.0-xi1-xi2
				gamma1       = K4/(K4+newh)
				gamma2       = 1.0-gamma1
				beta1        = K5/(K5+newh)
				beta2        = 1.0-beta1
				fH=co(i,ta)-((xi1+2.0*xi2)*co(i,tc)+gamma1*co(i,ts)+beta1*tb+K3/newh-newh)
				if(abs(fH).lt.1.0d-5) exit
			enddo
			co(i,h)=newh
			pHcount=0.0
			co3(i)=xi2*co(i,tc)
			hco3(i)=xi1*co(i,tc)
			h2co3(i)=xi3*co(i,tc)
	enddo
	tsed=tsed+delt_min
enddo		

select case (box)
	case (2)
	do i=2,nsed
		do j=1,spmax
			sp(j)%csed_cd(i)=co(i,j)
		enddo
		cas(shco3)%csed_cd(i)=hco3(i)
		cas(sco3)%csed_cd(i)=co3(i)
		cas(sh2co3)%csed_cd(i)=h2co3(i)
	enddo
	do j=1,spmax	
		Fsed(j,2)=diff(1,j)*(sp(j)%csed_cd(5)-sp(j)%csed_cd(1))/delxi_sed(5)
	enddo
	
	case (4)
	do i=2,nsed
		do j=1,spmax
			sp(j)%csed_id(i)=co(i,j)
		enddo
		cas(shco3)%csed_id(i)=hco3(i)
		cas(sco3)%csed_id(i)=co3(i)
		cas(sh2co3)%csed_id(i)=h2co3(i)
	enddo
	do j=1,spmax	
		Fsed(j,4)=diff(1,j)*(sp(j)%csed_id(5)-sp(j)%csed_id(1))/delxi_sed(5)
	enddo
	
	case (6)
	do i=2,nsed
		do j=1,spmax
			sp(j)%csed_pd(i)=co(i,j)
		enddo
		cas(shco3)%csed_pd(i)=hco3(i)
		cas(sco3)%csed_pd(i)=co3(i)
		cas(sh2co3)%csed_pd(i)=h2co3(i)
	enddo
	do j=1,spmax
		Fsed(j,6)=diff(1,j)*(sp(j)%csed_pd(5)-sp(j)%csed_pd(1))/delxi_sed(5)
	enddo
end select

!___Write files	
!________________________________________________________
!if((count.eq.tsave).AND.(aaa.eq.rsed)) then
!	do i=1,nsed		
!			write(3010,*) (rate1(i))
!			write(3011,*) (rate2(i))
!			write(3012,*) (rate3(i))
!			write(3013,*) (rate4(i))
!			write(3014,*) (rate5(i))
!			write(3015,*) (rate6(i))
!			write(3016,*) (rate7(i))
!			write(3017,*) (rate8(i))
!			write(3018,*) (rate11(i))
!			write(3019,*) (rate12(i))
!			write(3020,*) (rate13(i))
!	enddo
!endif

return 
end

