!	*****************************
	subroutine init
!	*****************************
!	initialize variables
!	last modified:

	use globals
	
! grid: Set grid strucutre of the interior ocean 
!	*****************************
	do i=1,nmax
		delxi(i)=(i-1)*10.0
	enddo	
	
	dxa(1)=delxi(2)-delxi(1)
	dxa(nmax)=delxi(nmax)-delxi(nmax-1)
	do i=2,nmax-1
	dxp(i)= delxi(i+1)-delxi(i)
	dxm(i)= delxi(i)-delxi(i-1)
	dxa(i)=(dxp(i)+dxm(i))/2.d0
	enddo

!	 sediment: grid
!	*****************************	  
	do j=1,nsed
		 delxi_sed(j)=1.0/100.0*(100.0*(((j-1.0)**2.0+20.0**2.0)**0.5-20.0))/((100.0**2+20.0**2)**0.5-20.0);		! sediment depth in m
	enddo
	
	dxa_sed(1)=delxi_sed(2)-delxi_sed(1)
	dxp_sed(1)=delxi_sed(2)-delxi_sed(1)
	dxa_sed(nsed)=delxi_sed(nsed)-delxi_sed(nsed-1)
	dxp_sed(nsed)=delxi_sed(nsed)-delxi_sed(nsed-1)
	do i=2,nsed-1
	dxp_sed(i)= delxi_sed(i+1)-delxi_sed(i)
	dxm_sed(i)= delxi_sed(i)-delxi_sed(i-1)
	dxa_sed(i)=(dxp_sed(i)+dxm_sed(i))/2.d0
	enddo


!  ocean: transport parameters
!	*****************************
	wi  =-0.7				! m/yr (negative!)
	q	=0.0023				! 1/yr
	cq  =0.0043				! 1/yr
	hex =53.0				! m/yr
	chex=30.0				! m/yr
	
	do i=1,nmax
		disp(i) = 1000.0	! m2/yr
		if (i.lt.11) then
			iup(i)=up
			iq(i) =cq		
		else
			iup(i)=0.0
			iq(i)=0.0
		endif
	enddo
	
	
	set_poc=18250.0			!m/yr
	wdepth(cd)=100.0
	wdepth(pd)=3500.0
	wdepth(id)=3500.0
	wdepth(ps)=25.0
	wdepth(cs)=25.0
	wdepth(is)=25.0
	
!	 atmosphere: PAL conversion
!	*****************************	
	PALo2	    =0.21
	PALco2		=0.000365
	factor_co2  =1.0
	factor_o2   =1.0			!-
	mass_o2PAL  =38.0d21
	mass_co2PAL =0.051d21
	mass_o2		=38.0d21*factor_co2	!mmol
	mass_co2	=0.051d21*factor_o2	!mmol

!	 continent: weathering fluxes
!	*****************************		
	fsilw =4.8E15		! mmol yr-1
	fbasw =2.0E15
	fcarbw=13.44E15
	fkerw =5.0E15
	fpw	  =0.9E15
	fairseaco2=fvoltc-2.0*fsilw-2.0*fbasw-fcarbw
	fairseao2=fkerw
	
	sp(tem)%atm(cs)	= 20.0					    ! initialize concentration in the atmosphere above the coastal ocean
	sp(tem)%atm(ps)	= -1.0					    ! initialize concentration in the atmosphere above the polar ocean
	sp(tem)%atm(is)	= 20.0					    ! initialize concentration in the atmosphere above the interior ocean
	
!	 continent/ocean: volcanic and hydrothermal fluxes
!	*****************************	  
	 fvoltc=6.8E15							! volcanic CO2 input [mmol/yr]
	 fmortc=6.0E14							! mid-oceanic ridge DIC flux [mmol/yr]
	 fmorta=0.13E14							! mid-oceanic ridge TA  flux [mmol/yr]
	 fmorch4=0.1535E14						! mid-oceanic ridge CH4 flux [mmol/yr]
	 fmorh2s=5.22E14						! mid-oceanic ridge H2S flux [mmol/yr]
	
!  sediment: transport parameters
!	*****************************
	omega(cd)=0.005		! m/yr
	omega(id)=0.001		! m/yr
	omega(pd)=0.001		! m/yr
	
	Db(cd)=28.0d-4			! m2/yr
	Db(id)=1.3d-4			! m2/yr
	Db(pd)=1.3d-4			! m2/yr
	
!	ocean biogeochemistry:  Rate constants
!	*****************************
	nc		=0.1509					!N/C ratio organic matter
	pc		=9.4340d-3				!P/C ratio organic matter
	nc_sed  =0.1509
	pc_sed  =9.4340d-3
	mu1		=8000.0					!maximum rate of export production [mmol C m-3 yr-1]
	mu2		=8000.0					!maximum rate of export production/ nitrogen fixers [mmol C m-3 yr-1]
	knit	=6.0					!maximum nitrification rate [m3 mmol-1 yr-1]
	kmreox	=6.0					!maximum rate of methane reoxidation [m3 mmol-1 yr-1]
	ksreox	=6.0					!maximum rate of sulfide reoxidation [m3 mmol-1 yr-1]
	kaom	=6.0					!maximum rate of anaerobic methane oxidation [m3 mmol-1 yr-1]
	a		=0.0035					!parameter reactive continuum model [yr]
	nu		=0.6					!parameter reactive continuum model [-]
	nu_po	=1.5					!parameter reactive continuum model [-]
	kmo2	=8.0					![mmol/m3] half saturation concentration O2
	kmno3	=10.0					![mmol/m3] half saturation concentration NO3
	kmso4	=1000.0					![mmol/m3] half saturation concentration SO4
	kpyr    =0.1					!pyrite formation [mmol m-3 yr-1]
	h2s_0   =0.1                    !half-saturation [mmol m-3 yr-1]
	rpicpoc =0.08					!caco3-poc export flux ratio [-]
	rpicpoc_po=0.02
	kcaco3  =10.0					!CaCO3 precipitation/dissolution [yr-1]
	nca     =1.0					!order of dissolution reaction
	kreef   =100.0					!reef production [mmol m-2 yr-1]
	KO2redox=20.0					!MM constant secondary redox reaction [mmol m-3]
	KSO4redox=1000.0					!MM constant secondary redox reaction [mmol m-3]


!  sediment: define porosity profile
!	*****************************
	por_0   = 0.9 
	por_n   = 0.6 
	attpor  = 0.00013
	
	do j=1,nsed
		por_d(j)=0.8!((por_n+(por_0-por_n)*exp(-attpor*delxi_sed(j))))
		sd(j)=(1.0-por_d(j))/por_d(j)
	enddo
	
!	sediment biogeochemistry:  Rate constants
!	*****************************	
	nu_sed =0.12			! [-] free parameter RC model
	a_sed  =10.0			! [yr]free parameter RC model 

	kmo2_sed=8.0			! [mmol/m3] half saturation concentration O2
	kmno3_sed=10.0			! [mmol/m3] half saturation concentration NO3
	kmso4_sed=1000.0		! [mmol/m3] half saturation concentration SO4
	knit_sed=3.0
	kaom_sed=1.0
	kmreox_sed=1.0
	ksreox_sed=2.0
	kapa=0.01				![yr-1] precipitation constant for apatite
	adpo4_ox=200.0*0.575
	adpo4_anox=1.9*0.575
	adnh4 =1.3
	po4_eq=100.0				!equlibrium concentration for apatite precipitation

!	biogeochemistry:  Assign values to species characteristics
!	*****************************
!___Ca
ca=10900.0										! constant concentration in the ocean/sediment

!___TB
tb=425.0										! constant concentration in the ocean/sediment

!___POC
   sp(poc)%name  = 'POC'						! name
   sp(poc)%state = 1						    ! state
   sp(poc)%cpd   = 1.0							! initialize export flux in the deep polar ocean
   sp(poc)%cps   = 1.0							! initialize export flux in the deep polar ocean
   sp(poc)%ccd   = 1.0						    ! initialize export flux in the deep coastal ocean
   sp(poc)%cis   = 1.0						    ! initialize export flux in the surface layer of the interior ocean
   sp(poc)%ccs   = 1.0						    ! initialize export flux in the surface layer of the coastal ocean

   do i=1,nmax
	sp(poc)%cid(i)		= 1.0					!initialize export flux field interior ocean
	if(i.lt.nsed+1)then
	sp(poc)%csed_cd(i)= 900.0/(omega(cd)*(1.0-por_d(1))) *(5.0)**(0.12)/(5.00+delxi_sed(i)/omega(cd))**(0.12)						!initialize sediment concentration fields
	sp(poc)%csed_id(i)= 90.0/(omega(id)*(1.0-por_d(1))) *(10.0)**(0.12)/(10.0+delxi_sed(i)/omega(id))**(0.12)
	sp(poc)%csed_pd(i)= 90.0/(omega(pd)*(1.0-por_d(1))) *(10.0)**(0.12)/(10.0+delxi_sed(i)/omega(pd))**(0.12)
	sp(poc)%diff(i)   = 0.0						!initialize sediment dispersion coefficient
	endif
   enddo

!___Temperature
   sp(tem)%name		= 'tem'						! name
   sp(tem)%state	= 0							! state
   sp(tem)%gex		= 76.0				        ! exchange velocity ocean-atmosphere
   sp(tem)%cpd		= 4.0						! initialize concentration in the deep polar ocean
   sp(tem)%cps		= 1.0						! initialize concentration in the deep polar ocean
   sp(tem)%ccd		= 4.0					    ! initialize concentration in the deep coastal ocean
   sp(tem)%cis		= 10.0						! initialize concentration in the surface layer of the interior ocean
   sp(tem)%ccs		= 10.0						! initialize concentration in the surface layer of the coastal ocean
  ! sp(tem)%atm(cs)	= 15.0					    ! initialize concentration in the atmosphere above the coastal ocean
  ! sp(tem)%atm(ps)	= -1.0					    ! initialize concentration in the atmosphere above the polar ocean
  ! sp(tem)%atm(is)	= 15.0					    ! initialize concentration in the atmosphere above the interior ocean

   do i=1,nmax
	sp(tem)%cid(i) = 4.0						! initialize concentration field interior ocean 
   enddo
   
!___Oxygen
   sp(o2)%name		= 'ZO2'						! name
   sp(o2)%state		= 0							! state
   sp(o2)%gex		= 100.0						! exchange velocity ocean-atmosphere
   sp(o2)%cpd		= 200.0						! initialize concentration in the deep polar ocean
   sp(o2)%cps		= 200.0						! initialize concentration in the deep polar ocean
   sp(o2)%ccd		= 200.0					    ! initialize concentration in the deep coastal ocean
   sp(o2)%cis		= 200.0						! initialize concentration in the surface layer of the interior ocean
   sp(o2)%ccs		= 200.0						! initialize concentration in the surface layer of the interior ocean
   sp(o2)%atm(cs)	= PALo2					    ! initialize partial pressure in the atmosphere above the coastal ocean
   sp(o2)%atm(ps)	= PALo2					    ! initialize partial pressure in the atmosphere above the polar ocean
   sp(o2)%atm(is)	= PALo2					    ! initialize partial pressure in the atmosphere above the interior ocean
   sp(o2)%sol(cs)	= 200.0					    ! initialize saturation concentration 
   sp(o2)%sol(ps)	= 200.0					    ! initialize saturation concentration 
   sp(o2)%sol(is)	= 200.0					    ! initialize saturation concentration
   do i=1,nmax
	sp(o2)%cid(i) = 200.0						! initialize concentration field interior ocean 
	if(i.lt.nsed+1)then
		sp(o2)%csed_cd(i)= 1.0!10.0d-10			! initialize sediment concentration fields
		sp(o2)%csed_id(i)= 1.0!10.0d-10
		sp(o2)%csed_pd(i)= 1.0!10.0d-10
		sp(o2)%diff(i)   = 0.04590				! initialize sediment dispersion coefficient [m2/yr]
	endif
   enddo

!___Nitrate
   sp(no3)%name		= 'NO3'						! name
   sp(no3)%state	= 0							! state
   sp(no3)%gex		= 0.0						! exchange velocity ocean-atmosphere
   sp(no3)%cpd		= 5.0						! initialize concentration in the deep polar ocean
   sp(no3)%cps		= 5.0						! initialize concentration in the deep polar ocean
   sp(no3)%ccd		= 5.0					    ! initialize concentration in the deep coastal ocean
   sp(no3)%cis		= 5.0						! initialize concentration in the surface layer of the interior ocean
   sp(no3)%ccs		= 5.0						! initialize concentration in the surface layer of the interior ocean
   sp(no3)%atm(cs)	= 0.0					    ! initialize concentration in the atmosphere above the coastal ocean
   sp(no3)%atm(ps)	= 0.0					    ! initialize concentration in the atmosphere above the polar ocean
   sp(no3)%atm(is)	= 0.0					    ! initialize concentration in the atmosphere above the interior ocean

   do i=1,nmax
	sp(no3)%cid(i) = 5.0						! initialize concentration field interior ocean 
	if(i.lt.nsed+1)then
		sp(no3)%csed_cd(i)= 1.0!10.0d-10			! initialize sediment concentration fields
		sp(no3)%csed_id(i)= 1.0!10.0d-10
		sp(no3)%csed_pd(i)= 1.0!10.0d-10
		sp(no3)%diff(i)   = 0.04110				! initialize sediment dispersion coefficient [m2/yr]
	endif
   enddo
   


!___Ammonium
   sp(nh4)%name		= 'NH4'						! name
   sp(nh4)%state	= 0							! state
   sp(nh4)%gex		= 0.0						! exchange velocity ocean-atmosphere
   sp(nh4)%cpd		= 0.0						! initialize concentration in the deep polar ocean
   sp(nh4)%cps		= 0.0						! initialize concentration in the deep polar ocean
   sp(nh4)%ccd		= 0.0					    ! initialize concentration in the deep coastal ocean
   sp(nh4)%cis		= 0.0						! initialize concentration in the surface layer of the interior ocean
   sp(nh4)%ccs		= 0.0						! initialize concentration in the surface layer of the interior ocean
   sp(nh4)%atm(cs)	= 0.0					    ! initialize concentration in the atmosphere above the coastal ocean
   sp(nh4)%atm(ps)	= 0.0					    ! initialize concentration in the atmosphere above the polar ocean
   sp(nh4)%atm(is)	= 0.0					    ! initialize concentration in the atmosphere above the interior ocean
   
	do i=1,nmax
		sp(nh4)%cid(i) = 0.0					! initialize concentration field interior ocean 
		if(i.lt.nsed+1)then
			sp(nh4)%csed_cd(i)= 10.0d-10		! initialize sediment concentration fields
			sp(nh4)%csed_id(i)= 10.0d-10
			sp(nh4)%csed_pd(i)= 10.0d-10
			sp(nh4)%diff(i)   = 0.0421/(1.0+adnh4)! initialize sediment dispersion coefficient [m2/yr]
		endif
   enddo
   
!___Phosphate
   sp(po4)%name		= 'PO4'						! name
   sp(po4)%state	= 0							! state
   sp(po4)%gex		= 0.0						! exchange velocity ocean-atmosphere
   sp(po4)%cpd		= 1.5						! initialize concentration in the deep polar ocean
   sp(po4)%cps		= 1.5						! initialize concentration in the deep polar ocean
   sp(po4)%ccd		= 1.5					    ! initialize concentration in the deep coastal ocean
   sp(po4)%cis		= 1.5						! initialize concentration in the surface layer of the interior ocean
   sp(po4)%ccs		= 1.5						! initialize concentration in the surface layer of the interior ocean
   sp(po4)%atm(cs)	= 0.0					    ! initialize concentration in the atmosphere above the coastal ocean
   sp(po4)%atm(ps)	= 0.0					    ! initialize concentration in the atmosphere above the polar ocean
   sp(po4)%atm(is)	= 0.0					    ! initialize concentration in the atmosphere above the interior ocean
   do i=1,nmax
	sp(po4)%cid(i)	= 1.5						! initialize concentration field interior ocean 
	if(i.lt.nsed+1)then
		sp(po4)%csed_cd(i)= 10.0d-10			! initialize sediment concentration fields
		sp(po4)%csed_id(i)= 10.0d-10
		sp(po4)%csed_pd(i)= 10.0d-10
		sp(po4)%diff(i)   = 0.0396				! initialize sediment dispersion coefficient [m2/yr]
	endif
   enddo
   
!___Sulfate
   sp(so4)%name		= 'SO4'						! name
   sp(so4)%state	= 0							! state
   sp(so4)%gex		= 0.0						! exchange velocity ocean-atmosphere
   sp(so4)%cpd		= 28000.0						! initialize concentration in the deep polar ocean
   sp(so4)%cps		= 28000.0						! initialize concentration in the deep polar ocean
   sp(so4)%ccd		= 28000.0					    ! initialize concentration in the deep coastal ocean
   sp(so4)%cis		= 28000.0						! initialize concentration in the surface layer of the interior ocean
   sp(so4)%ccs		= 28000.0						! initialize concentration in the surface layer of the interior ocean
   sp(so4)%atm(cs)	= 0.0					    ! initialize concentration in the atmosphere above the coastal ocean
   sp(so4)%atm(ps)	= 0.0					    ! initialize concentration in the atmosphere above the polar ocean
   sp(so4)%atm(is)	= 0.0					    ! initialize concentration in the atmosphere above the interior ocean

   do i=1,nmax
	sp(so4)%cid(i) = 28000.0						! initialize concentration field interior ocean 
	if(i.lt.nsed+1)then
		sp(so4)%csed_cd(i)= 28000.0			! initialize sediment concentration fields
		sp(so4)%csed_id(i)= 28000.0
		sp(so4)%csed_pd(i)= 28000.0
		sp(so4)%diff(i)   = 0.0190				! initialize sediment dispersion coefficient [m2/yr]
	endif
   enddo
   
!___Methane
   sp(ch4)%name		= 'CH4'						! name
   sp(ch4)%state	= 0							! state
   sp(ch4)%gex		= 0.0						! exchange velocity ocean-atmosphere
   sp(ch4)%cpd		= 0.0						! initialize concentration in the deep polar ocean
   sp(ch4)%cps		= 0.0						! initialize concentration in the deep polar ocean
   sp(ch4)%ccd		= 0.0						! initialize concentration in the deep coastal ocean
   sp(ch4)%cis		= 0.0						! initialize concentration in the surface layer of the interior ocean
   sp(ch4)%ccs		= 0.0						! initialize concentration in the surface layer of the interior ocean
   sp(ch4)%atm(cs)	= 0.0						! initialize concentration in the atmosphere above the coastal ocean
   sp(ch4)%atm(ps)	= 0.0						! initialize concentration in the atmosphere above the polar ocean
   sp(ch4)%atm(is)	= 0.0						! initialize concentration in the atmosphere above the interior ocean

   do i=1,nmax
	sp(ch4)%cid(i)	= 0.0						! initialize concentration field interior ocean 
	if(i.lt.nsed+1)then
		sp(ch4)%csed_cd(i)= 0.0					! initialize sediment concentration fields
		sp(ch4)%csed_id(i)= 0.0
		sp(ch4)%csed_pd(i)= 0.0
		sp(ch4)%diff(i)   = 0.0303				! initialize sediment dispersion coefficient [m2/yr]
	endif
   enddo
   
!___Dissolved sulfide
   sp(ts)%name		= 'TOS'						! name
   sp(ts)%state	= 0								! state
   sp(ts)%gex		= 0.0						! exchange velocity ocean-atmosphere
   sp(ts)%cpd		= 0.0						! initialize concentration in the deep polar ocean
   sp(ts)%cps		= 0.0						! initialize concentration in the deep polar ocean
   sp(ts)%ccd		= 0.0					    ! initialize concentration in the deep coastal ocean
   sp(ts)%cis		= 0.0						! initialize concentration in the surface layer of the interior ocean
   sp(ts)%ccs		= 0.0						! initialize concentration in the surface layer of the interior ocean
   sp(ts)%atm(cs)	= 0.0					    ! initialize concentration in the atmosphere above the coastal ocean
   sp(ts)%atm(ps)	= 0.0					    ! initialize concentration in the atmosphere above the polar ocean
   sp(ts)%atm(is)	= 0.0					    ! initialize concentration in the atmosphere above the interior ocean

   do i=1,nmax
	sp(ts)%cid(i)	= 0.0						! initialize concentration field interior ocean 
	if(i.lt.nsed+1)then
		sp(ts)%csed_cd(i)= 0.0					! initialize sediment concentration fields
		sp(ts)%csed_id(i)= 0.0
		sp(ts)%csed_pd(i)= 0.0
		sp(ts)%diff(i)   = 0.0200				! initialize sediment dispersion coefficient [m2/yr]
	endif
   enddo
   
!___Dissolved inorg. carbon
   sp(tc)%name	= 'DIC'							! name
   sp(tc)%state	= 0								! state
   sp(tc)%gex		= 0.0						! exchange velocity ocean-atmosphere
   sp(tc)%cpd		= 2000.0					! initialize concentration in the deep polar ocean
   sp(tc)%cps		= 2000.0					! initialize concentration in the deep polar ocean
   sp(tc)%ccd		= 2000.0				    ! initialize concentration in the deep coastal ocean
   sp(tc)%cis		= 2000.0					! initialize concentration in the surface layer of the interior ocean
   sp(tc)%ccs		= 2000.0					! initialize concentration in the surface layer of the interior ocean
   sp(tc)%atm(cs)	= PALco2					! initialize partial pressure in the atmosphere above the coastal ocean
   sp(tc)%atm(ps)	= PALco2					! initialize partial pressure in the atmosphere above the polar ocean
   sp(tc)%atm(is)	= PALco2					! initialize partial pressure in the atmosphere above the interior ocean
   sp(tc)%sol(cs)	= 0.0						! initialize saturation concentration 
   sp(tc)%sol(ps)	= 0.0						! initialize saturation concentration 
   sp(tc)%sol(is)	= 0.0						! initialize saturation concentration
   
   do i=1,nmax
	sp(tc)%cid(i)	= 2000.0					! initialize concentration field interior ocean 
	if(i.lt.nsed+1)then
		sp(tc)%csed_cd(i)= 2000.0				! initialize sediment concentration fields
		sp(tc)%csed_id(i)= 2000.0
		sp(tc)%csed_pd(i)= 2000.0
		sp(tc)%diff(i)   = 0.0195				! initialize sediment dispersion coefficient [m2/yr]
	endif
  enddo

!___Total Alkalinity
   sp(ta)%name	= 'ALK'							! name
   sp(ta)%state	= 0								! state
   sp(ta)%gex		= 0.0						! exchange velocity ocean-atmosphere
   sp(ta)%cpd		= 2330.0					! initialize concentration in the deep polar ocean
   sp(ta)%cps		= 2330.0					! initialize concentration in the deep polar ocean
   sp(ta)%ccd		= 2330.0				    ! initialize concentration in the deep coastal ocean
   sp(ta)%cis		= 2330.0					! initialize concentration in the surface layer of the interior ocean
   sp(ta)%ccs		= 2330.0					! initialize concentration in the surface layer of the interior ocean
   sp(ta)%atm(cs)	= 0.0					    ! initialize concentration in the atmosphere above the coastal ocean
   sp(ta)%atm(ps)	= 0.0					    ! initialize concentration in the atmosphere above the polar ocean
   sp(ta)%atm(is)	= 0.0					    ! initialize concentration in the atmosphere above the interior ocean
  
    do i=1,nmax
	sp(ta)%cid(i)	= 2330.0					! initialize concentration field interior ocean 
	if(i.lt.nsed+1)then
		sp(ta)%csed_cd(i)= 2000.0					! initialize sediment concentration fields
		sp(ta)%csed_id(i)= 2000.0
		sp(ta)%csed_pd(i)= 2000.0
		sp(ta)%diff(i)   = 0.0195				! initialize sediment dispersion coefficient [m2/yr]
	endif
  enddo

!___Protons
   sp(h)%name		= 'hpl'						! name
   sp(h)%state		= 1							! state
   sp(h)%gex		= 0.0					    ! exchange velocity ocean-atmosphere
   sp(h)%cpd		= 10.0**(-2.0)				! initialize concentration in the deep polar ocean
   sp(h)%cps		= 10.0**(-2.1)				! initialize concentration in the deep polar ocean
   sp(h)%ccd		= 10.0**(-2.0)				! initialize concentration in the deep coastal ocean
   sp(h)%cis		= 10.0**(-2.1)				! initialize concentration in the surface layer of the interior ocean
   sp(h)%ccs		= 10.0**(-2.1)				! initialize concentration in the surface layer of the interior ocean
   sp(h)%atm(cs)	= 0.0					! initialize concentration in the atmosphere above the coastal ocean
   sp(h)%atm(ps)	= 0.0					! initialize concentration in the atmosphere above the polar ocean
   sp(h)%atm(is)	= 0.0					! initialize concentration in the atmosphere above the interior ocean

   do i=1,nmax
	sp(h)%cid(i)	= 10.0**(-2.0)			! initialize concentration field interior ocean 
	if(i.lt.nsed+1)then
		sp(h)%csed_cd(i)= 10.0**(-2.0)		! initialize sediment concentration fields
		sp(h)%csed_id(i)= 10.0**(-2.0)
		sp(h)%csed_pd(i)= 10.0**(-2.0)
		sp(h)%diff(i)   = 0.0				! initialize sediment dispersion coefficient [m2/yr]
	endif
   enddo

!___13C
   sp(cheavy)%name		= 'heC'					! name
   sp(cheavy)%state		= 0						! state
   sp(cheavy)%gex		= 0.0					! exchange velocity ocean-atmosphere
   sp(cheavy)%cpd		= 425.0					! initialize concentration in the deep polar ocean
   sp(cheavy)%cps		= 425.0					! initialize concentration in the deep polar ocean
   sp(cheavy)%ccd		= 425.0					! initialize concentration in the deep coastal ocean
   sp(cheavy)%cis		= 425.0					! initialize concentration in the surface layer of the interior ocean
   sp(cheavy)%ccs		= 425.0					! initialize concentration in the surface layer of the interior ocean
   sp(cheavy)%atm(cs)	= 0.0					! initialize concentration in the atmosphere above the coastal ocean
   sp(cheavy)%atm(ps)	= 0.0					! initialize concentration in the atmosphere above the polar ocean
   sp(cheavy)%atm(is)	= 0.0					! initialize concentration in the atmosphere above the interior ocean

   do i=1,nmax
	sp(cheavy)%cid(i)	= 425.0						! initialize concentration field interior ocean 
	if(i.lt.nsed+1)then
		sp(cheavy)%csed_cd(i)= 425.0				! initialize sediment concentration fields
		sp(cheavy)%csed_id(i)= 425.0
		sp(cheavy)%csed_pd(i)= 425.0
		sp(cheavy)%diff(i)   = 0.0123				! initialize sediment dispersion coefficient [m2/yr]
	endif
   enddo
   
!___12C
   sp(clight)%name		= 'loC'					! name
   sp(clight)%state		= 0						! state
   sp(clight)%gex		= 0.0					! exchange velocity ocean-atmosphere
   sp(clight)%cpd		= 10900.0				! initialize concentration in the deep polar ocean
   sp(clight)%cps		= 10900.0				! initialize concentration in the deep polar ocean
   sp(clight)%ccd		= 10900.0				! initialize concentration in the deep coastal ocean
   sp(clight)%cis		= 10900.0				! initialize concentration in the surface layer of the interior ocean
   sp(clight)%ccs		= 10900.0				! initialize concentration in the surface layer of the interior ocean
   sp(clight)%atm(cs)	= 0.0					! initialize concentration in the atmosphere above the coastal ocean
   sp(clight)%atm(ps)	= 0.0					! initialize concentration in the atmosphere above the polar ocean
   sp(clight)%atm(is)	= 0.0					! initialize concentration in the atmosphere above the interior ocean

   do i=1,nmax
	sp(clight)%cid(i)	= 10900.0				! initialize concentration field interior ocean 
	if(i.lt.nsed+1)then
		sp(clight)%csed_cd(i)= 10900.0					!initialize sediment concentration fields
		sp(clight)%csed_id(i)= 10900.0
		sp(clight)%csed_pd(i)= 10900.0
		sp(clight)%diff(i)   = 0.0165			! initialize sediment dispersion coefficient [m2/yr]
	endif
   enddo
   
!___Carbonate
   sp(caco3)%name		= 'CAB'					! name
   sp(caco3)%state		= 1						! state
   sp(caco3)%gex		= 0.0					! exchange velocity ocean-atmosphere
   sp(caco3)%cpd		= 0.0					! initialize concentration in the deep polar ocean
   sp(caco3)%cps		= 0.0					! initialize concentration in the deep polar ocean
   sp(caco3)%ccd		= 0.0					! initialize concentration in the deep coastal ocean
   sp(caco3)%cis		= 0.0					! initialize concentration in the surface layer of the interior ocean
   sp(caco3)%ccs		= 0.0					! initialize concentration in the surface layer of the interior ocean
   sp(caco3)%atm(cs)	= 0.0					! initialize concentration in the atmosphere above the coastal ocean
   sp(caco3)%atm(ps)	= 0.0					! initialize concentration in the atmosphere above the polar ocean
   sp(caco3)%atm(is)	= 0.0					! initialize concentration in the atmosphere above the interior ocean

   do i=1,nmax
	sp(caco3)%cid(i)	= 0.0					! initialize concentration field interior ocean 
	if(i.lt.nsed+1)then
		sp(caco3)%csed_cd(i)= rpicpoc*400.0/(omega(cd)*(1.0-por_d(1)))				! initialize sediment concentration fields
		sp(caco3)%csed_id(i)= rpicpoc*100.0/(omega(cd)*(1.0-por_d(1)))
		sp(caco3)%csed_pd(i)= rpicpoc*100.0/(omega(cd)*(1.0-por_d(1)))
		sp(caco3)%diff(i)   = 0.0   			! initialize sediment dispersion coefficient [m2/yr]
	endif
   enddo
   
   !___Carbonic Acid
   cas(sh2co3)%name		= 'H2C'					! name
   cas(sh2co3)%cpd		= 0.0					! initialize concentration in the deep polar ocean
   cas(sh2co3)%cps		= 0.0					! initialize concentration in the deep polar ocean
   cas(sh2co3)%ccd		= 0.0					! initialize concentration in the deep coastal ocean
   cas(sh2co3)%cis		= 0.0					! initialize concentration in the surface layer of the interior ocean
   cas(sh2co3)%ccs		= 0.0					! initialize concentration in the surface layer of the interior ocean
  
   do i=1,nmax
	cas(sh2co3)%cid(i)	= 0.0					! initialize concentration field interior ocean 
	if(i.lt.nsed+1)then
		cas(sh2co3)%csed_cd(i)= 0.0				! initialize sediment concentration fields
		cas(sh2co3)%csed_id(i)= 0.0
		cas(sh2co3)%csed_pd(i)= 0.0
	endif
   enddo
   
!___Carbonic Acid
   cas(shco3)%name		= 'HCO'					! name
   cas(shco3)%cpd		= 0.0					! initialize concentration in the deep polar ocean
   cas(shco3)%cps		= 0.0					! initialize concentration in the deep polar ocean
   cas(shco3)%ccd		= 0.0					! initialize concentration in the deep coastal ocean
   cas(shco3)%cis		= 0.0					! initialize concentration in the surface layer of the interior ocean
   cas(shco3)%ccs		= 0.0					! initialize concentration in the surface layer of the interior ocean
  
   do i=1,nmax
	cas(shco3)%cid(i)	= 0.0					! initialize concentration field interior ocean 
	if(i.lt.nsed+1)then
		cas(shco3)%csed_cd(i)= 0.0				! initialize sediment concentration fields
		cas(shco3)%csed_id(i)= 0.0
		cas(shco3)%csed_pd(i)= 0.0
	endif
   enddo

!___Carbonic Acid
   cas(sco3)%name		= 'CO3'					! name
   cas(sco3)%cpd		= 0.0					! initialize concentration in the deep polar ocean
   cas(sco3)%cps		= 0.0					! initialize concentration in the deep polar ocean
   cas(sco3)%ccd		= 0.0					! initialize concentration in the deep coastal ocean
   cas(sco3)%cis		= 0.0					! initialize concentration in the surface layer of the interior ocean
   cas(sco3)%ccs		= 0.0					! initialize concentration in the surface layer of the interior ocean
  
   do i=1,nmax
	cas(sco3)%cid(i)	= 0.0					! initialize concentration field interior ocean 
	if(i.lt.nsed+1)then
		cas(sco3)%csed_cd(i)= 0.0				! initialize sediment concentration fields
		cas(sco3)%csed_id(i)= 0.0
		cas(sco3)%csed_pd(i)= 0.0
	endif
   enddo
   end
	
	  
	  