!	*****************************
	program main
!	*****************************
	  
	use globals
	implicit none
	integer:: t,i,j,k, count
	character(len=20) :: str1
	character(len=2)  :: p1
	real*8 AK0, BC

!___Initialize
!________________________________________________________
	call init
	!call weatheringinit				! uncomment if weathering routines are used
	!call initfile						! uncomment if initial files are used
	
!___Open files
!________________________________________________________
!_Atmosphere
OPEN (UNIT=1, FILE='PCO2.dat',  STATUS='UNKNOWN')
OPEN (UNIT=2, FILE='PO2.dat',  STATUS='UNKNOWN')

!___State Variables
	do j=1, spmax
	    str1=trim(sp(j)%name) // '.dat'
		OPEN (UNIT=10+j, FILE=str1,  STATUS='UNKNOWN') 
		str1=trim(sp(j)%name) // 'box.dat'
		OPEN (UNIT=100+j, FILE=str1,  STATUS='UNKNOWN')
	enddo
	do j=1, spmax
	    str1=trim(sp(j)%name) // 'sed.dat'
		OPEN (UNIT=1000+j, FILE=str1,  STATUS='UNKNOWN')
	enddo
!___Carbonate System
	do j=1, casmax
	    str1=trim(cas(j)%name) // '.dat'
		OPEN (UNIT=70+j, FILE=str1,  STATUS='UNKNOWN')
		str1=trim(cas(j)%name) // 'box.dat'
		OPEN (UNIT=700+j, FILE=str1,  STATUS='UNKNOWN')
	enddo
	do j=1, casmax
	    str1=trim(cas(j)%name) // 'sed.dat'
		OPEN (UNIT=7000+j, FILE=str1,  STATUS='UNKNOWN')
	enddo
!___Rates	
	do j=1,16
		write (p1, '(I2)') 10+j-1
		str1='r'//trim(p1)// '.dat'
		OPEN (UNIT=2010+j-1, FILE=str1,  STATUS='UNKNOWN')
		str1='r'//trim(p1)// 'box.dat'
		OPEN (UNIT=2210+j-1, FILE=str1,  STATUS='UNKNOWN')
	enddo
		do j=1,11
		write (p1, '(I2)') 10+j-1
		str1='rsed'//trim(p1)// '.dat'
		write(6,*) str1, 3010+j-1
		OPEN (UNIT=3010+j-1, FILE=str1,  STATUS='UNKNOWN')
	enddo
	OPEN (UNIT=10000, FILE='Flux.dat',  STATUS='UNKNOWN')
	OPEN (UNIT=666, FILE='dhdt.dat',  STATUS='UNKNOWN')


	count=0
	
	
!___Main time loop
!________________________________________________________
	do t=1, tmax
		write(6,*) t*delt
		count=count+1


! uncomment if weathering routines are used	(transient sim)	
!___Weathering
!________________________________________________________		
	!call runoff_cal(factor_co2)
	!call weathering(fsilw,fbasw,fcarbw,fkerw,fpw,fnitro,factor_co2)

	!write(*,*)'     '
	
	!write(*,*)'All fluxes in 10d15 mmoles/yr:'
	!write(*,*)'     '
	!write(*,*)'Granitic weathering   : ',fsilw/1.d15,' Ca flux'
	!write(*,*)'Basaltic weathering   : ',fbasw/1d15,' Ca flux'
	!write(*,*)'Kerogen weathering    : ',fkerw/1d+15,' crustal C flux'
	!write(*,*)'Carbonate weathering  : ',fcarbw/1d15,' crustal C flux'
	!write(*,*)'Phosphorus weathering : ',fpw/1d15,' P flux'
	!write(*,*)'Nitrogen weathering   : ',fnitro/1d+12,' N flux'		

!___Ocean Transport
!________________________________________________________			
		do j=1, spmax
			if(sp(j)%state.eq.0)then
				call transport_ocean(sp(j)%cid,sp(j)%cis,sp(j)%cpd,sp(j)%cps,sp(j)%ccs,sp(j)%ccd,sp(j)%atm(cs),sp(j)%atm(ps),sp(j)%atm(is),j)
			endif
		enddo

!___Ocean Biogeochemsitry
!________________________________________________________			
		do j=1,rbio
			call biogeo(count,j,t)
		enddo
		
!___Sediment Biogeochemistry
!________________________________________________________		
		sp(so4)%cid(nmax)=28000.0
		sp(so4)%ccd=28000.0
		sp(so4)%cpd=28000.0
		
		do k=1,rsed
			do j=1,spmax
				if(j.ne.h)then
						call transport_sed(sp(j)%csed_cd, sp(j)%ccd, sp(j)%state, omega(cd), j, cd)
						call transport_sed(sp(j)%csed_id, sp(j)%cid(nmax), sp(j)%state, omega(id), j, id)
						call transport_sed(sp(j)%csed_pd, sp(j)%cpd, sp(j)%state, omega(pd), j, pd)
				endif
			end do
			call diag(count,t,k,cd)	! 3 sediment columns (coastal, interior, polar)
			call diag(count,t,k,id)
			call diag(count,t,k,pd)
		enddo

				

!___Write files: Note oceanic and benthic rate files are saved in biogeo.f90 and diag.f90	
!________________________________________________________
		if(count.eq.tsave) then
		
!_________Atmosphere__________________________		
			write(1, '(F10.2)') sp(tc)%atm(cs)/0.000270
			write(2, '(F10.2)') sp(o2)%atm(cs)/0.21
			do j=1, spmax
!_________Ocean/Sediment__________________________
				if(j.eq.h)then
					do i=1,nmax
						write(10+j,*) (log10(sp(j)%cid(i)))
					enddo
					write(100+j,'(F10.2, F10.2, F10.2, F10.2, F10.2)') log10(sp(j)%cis), log10(sp(j)%cps),&
																	   log10(sp(j)%cpd), log10(sp(j)%ccs), log10(sp(j)%ccd)
					do i=1, nsed
						write(1000+j,*) log10(sp(j)%csed_cd(i)), log10(sp(j)%csed_id(i)), log10(sp(j)%csed_pd(i))
					enddo
					write(10000,*) Fsed(j,2), Fsed(j,4), Fsed(j,6)
				else
					do i=1,nmax
						write(10+j,*) (sp(j)%cid(i))
					enddo
					write(100+j,'(F10.2, F10.2, F10.2, F10.2, F10.2)') sp(j)%cis, sp(j)%cps, sp(j)%cpd, sp(j)%ccs, sp(j)%ccd
					do i=1, nsed
						write(1000+j,*) sp(j)%csed_cd(i), sp(j)%csed_id(i), sp(j)%csed_pd(i)
					enddo
					write(10000,*) Fsed(j,2), Fsed(j,4), Fsed(j,6)
				endif
			enddo
!_________Carbonate System__________________________
			do j=1, casmax
				do i=1,nmax
					write(70+j,*) (cas(j)%cid(i))
				enddo
				write(700+j,'(F10.2, F10.2, F10.2, F10.2, F10.2)') cas(j)%cis, cas(j)%cps, cas(j)%cpd, cas(j)%ccs, cas(j)%ccd
				do i=1, nsed
					write(7000+j,*) cas(j)%csed_cd(i), cas(j)%csed_id(i), cas(j)%csed_pd(i)
				enddo
			enddo
			
		count=0
		endif
	enddo
	  
!___Close files
!________________________________________________________
close(1)
close(2)
	do j=1, spmax
		close(10+j)
		close(100+j)
		close(1000+j)
	enddo
	do j=1, casmax
		close(70+j)
		close(700+j)
		close(7000+j)
	enddo
	do j=1,16
		close(2000+10+(j-1))
		close(2200+10+(j-1))
	enddo
	do j=1,11
		close(3010+j-1)
	enddo
	close(10000)
	close(666)

end
	  
	  