!	*****************************
	subroutine transport_ocean(co, cois, copd, cops, cocs, cocd, s)
!	*****************************
!   calculate dC/dt|trans
!	last modified:

	use globals
    !implicit DOUBLE PRECISION(a-h,o-z)

	DOUBLE PRECISION di(nmax),aa(nmax),c(nmax),bb(nmax),rr(nmax),co(nmax),gam(nmax),cold(nmax),fl(nmax),ctrans(nmax)
	DOUBLE PRECISION bet, copd, cois, cops,cocs, cocd, dtdxp, dtdxm
	DOUBLE PRECISION cfl, f, philen, rg, kk
	DOUBLE PRECISION newcois, newcops, newcopd, newcocs, newcocd, sumcois, sumup, atmc, atmp, atmi
	integer n, j, nsp, za, s

	do j=1,nmax
		ctrans(j)=co(j)
	enddo

!___surface layer of the coastal ocean
!	**************************************************************************
	newcocs=cocs- chex/D_tc*(cocs-cocd)*delt- Ai/Ac*chex/D_tc*(cocs-cois)*delt
	
!___surface layer of the interior ocean
!	**************************************************************************
	newcois=cois+disp(1)*(co(6)-cois)/(6.0*dxa(1))*1.0/(D_tc)*delt-chex/D_tc*(cois-cocs)*delt!-chex/D_tc*(cois-cops)*delt
			
!___surface layer of the polar ocean
!	**************************************************************************
	newcops=cops-hex/D_tc*(cops-copd)*delt-Ai/Ap*wi/D_tc*(cois-cops)*delt!- Ai/Ap*chex/D_tc*(cops-cois)*delt!
	
!___deep layer of the polar ocean
!	**************************************************************************
	sumcois=0.d0
	do j=1, nmax
		sumcois=sumcois+(co(j)*dxa(j))
	enddo
	newcopd=copd+ hex/D_do*(cops-copd)*delt-Ai/Ap*wi/D_do*(cops-copd)*delt+Ai/Ap*q*(sumcois/D_do-copd)*delt
	
!___deep layer of the coastal ocean
!	**************************************************************************
	sumup=0.d0
	za=10.0
	do j=1, za
		sumup=sumup+(co(j)*10.0)
	enddo
	newcocd=cocd+ chex/D_co*(cocs-cocd)*delt+Ai/Ac*cq*(sumup/100.0-cocd)*delt


!___deep interior ocean
!	**************************************************************************
!___dispersive term___________________________________________________________
! dispersion coefficient depth-dependent, dispersion coefficients taken at 1/2 grid points, e.g. Boudreau, 1998 p.330
! boundary conditions only applied to dispersive term and c(0), c(nmax) taken as bc for TVD scheme

!---boundary conditions
! upper boundary condition: fixed concentration
	aa(1) = 0.0
	c(1)  = 0.0
	bb(1) = 1.0
	di(1) = cois ! conc. surface layer

! lower boundary condition: flux condition+thermohaline circulation	
	
	 aa(nmax) = 0.0
	 c(nmax)  = 0.0
	 bb(nmax) = 1.0
	 di(nmax) = co(nmax-1)+2.0*10.0/disp(nmax)*(wi*co(nmax)-wi*copd) 
	  
!----coeff of tridiag. matrix
	do i=2,nmax-1
		dtdxp = delt/(2.d0*dxp(i)*dxa(i)) ! see Boudreau 1998 for discretization on uneven grids, =(delxi(i+1)-delxi(i))*((delxi(i+1)-delxi(i))+(delxi(i)-delxi(i-1)))
	    dtdxm = delt/(2.d0*dxm(i)*dxa(i))

		aa(i) = -(disp(i-1)+disp(i))/2.d0*dtdxm
		c(i)  = -(disp(i+1)+disp(i))/2.d0*dtdxm
		bb(i) = 1.d0+(disp(i+1)+disp(i))/2.d0*dtdxp+(disp(i-1)+disp(i))/2.d0*dtdxm
		rr(i) = 1.d0-(disp(i+1)+disp(i))/2.d0*dtdxp-(disp(i-1)+disp(i))/2.d0*dtdxm
		di(i) = -c(i)*co(i+1)+rr(i)*co(i)-aa(i)*co(i-1)
	end do
		  
!___solve tridiagonal matrix
	bet=bb(1)
	co(1)=di(1)/bet
	do j=2,nmax
		gam(j)=c(j-1)/bet
		bet=bb(j)-aa(j)*gam(j)
		co(j)=(di(j)-aa(j)*co(j-1))/bet
	end do

	do j=nmax-1,1,-1
		co(j)=co(j)-gam(j+1)*co(j+1)
	end do

	
!___advective and source terms___________________________________________________________
	do j=1,nmax
		cold(j)=co(j)
	enddo
	cfl = abs(wi*dtdxp)
	
!---calculate flux at i=1
	!if (wi.gt.0.0) then
	!	f = cold(2)-cold(1)
	!	rg = 0.d0
	!	philen = max(0.d0,min(2.d0,2.d0*rg,(2.d0-cfl+rg*(1.d0+cfl))/3.d0))
	!	fl(1) = wi*(cold(1)+0.5*(1.0-cfl)*philen*f)
	!else
		f = cold(1)-cold(2)
		rg = 0.d0
		philen = max(0.d0,min(2.d0,2.d0*rg,(2.d0-cfl+rg*(1.d0+cfl))/3.d0))
		fl(1)  = wi*(cold(2)+0.5*(1.0-cfl)*philen*f)
	!endif

!---TVD scheme with flux limiter for inner grid points- boundary concentrations c(0), c(nmax) calculated in disp step
	do i = 2,nmax-1
		dtdxa = delt/(dxa(i))
        dtdxp = delt/(dxp(i))
		
		!if (wi.gt.0.0) then
		!	f = cold(i+1)-cold(i)
		!	if (dabs(f).gt.1.e-35) then
		!		rg = (cold(i)-cold(i-1))/f
		!		philen = max(0.d0,min(2.d0,2.d0*rg,(2.d0-cfl+rg*(1.d0+cfl))/3.d0))
		!	else
		!		philen = 0.0
		!	endif
		!	fl(i) = wi*(cold(i)+0.5*(1.0-cfl)*philen*f)
		!	co(i) = cold(i)-dtdxa*(fl(i)-fl(i-1))-q*(cold(i)-copd)*delt-iq(i)*(cold(i)-cocd)*delt	
		!	dsumT(i,s)=(co(i)-ctrans(i))/delt		
		!endif
		
		!if (wi.lt.0.0) then
			f = cold(i)-cold(i+1)
			if (dabs(f).gt.1.e-35) then
				if (i.eq.nmax-1) then
					rg=0.d0
				else
					rg = (cold(i+1)-cold(i+2))/f
				endif
				philen = max(0.d0,min(2.d0,2.d0*rg,(2.d0-cfl+rg*(1.d0+cfl))/3.d0))
			else
				philen = 0.0
			endif
			fl(i) = wi*(cold(i+1)+0.5*(1.0-cfl)*philen*f)
			if(i.lt.11)then
				co(i) = cold(i)-dtdxa*(fl(i)-fl(i-1))-q*(cold(i)-copd)*delt-cq*(cold(i)-cocd)*delt
			else
				co(i) = cold(i)-dtdxa*(fl(i)-fl(i-1))-q*(cold(i)-copd)*delt	
			endif
		!endif
	end do
	
!___write new concentrations
	cois=newcois
	cops=newcops
	copd=newcopd
	cocd=newcocd
	cocs=newcocs

	return
end





	   



	  